/* ====================================================================================================================

  The copyright in this software is being made available under the license included below.

  Copyright (c) 2010, France Telecom S.A., NTT Corp, NTT DOCOMO, Inc., DOCOMO Communications Laboratories USA, Inc.,
  Panasonic Corp., Technicolor S.A. All rights reserved.

  By receiving and/or using this software, you agree to be bound by the following license. Subject to the terms of
  this agreement, this license is a non-exclusive license to distribute and use the software, in source and binary
  forms, with or without modification, permitted only for the purpose of developing standards within the Joint
  Collaborative Team on Video Coding and for testing and promoting such standards. The license is subject to the
  following conditions:

    * Distributions of source code must retain the above copyright notice, this list of conditions and the following
      disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions, and the
      following disclaimer in the documentation and/or other materials provided with such distribution.
    * Neither the name of France Telecom S.A., NTT Corp, NTT DOCOMO, Inc.,
      DOCOMO Communications Laboratories USA, Inc., Panasonic Corp., Technicolor S.A nor the names of their
      contributors may be used to endorse or promote products derived from this software without specific prior
      written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, EQUIPMENT OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  THIS SOFTWARE MAY BE SUBJECT TO OTHER THIRD PARTY AND CONTRIBUTOR RIGHTS, INCLUDING PATENT RIGHTS, AND NO SUCH
  RIGHTS ARE GRANTED UNDER THIS LICENSE. ALL USERS AGREE TO INDEMNIFY AND HOLD HARMLESS THE ABOVE MENTIONED PARTIES
  TO THE COPYRIGHT AGAINST ANY AND ALL CLAIMS OR DEMANDS, INCLUDING WITHOUT LIMITATION INTELLECTUAL PROPERTY RIGHTS
  OF THIRD PARTIES, WHICH MIGHT ARISE UNDER THE USE OR DISTRIBUTION OF THIS SOFTWARE.

 * ====================================================================================================================
*/

/*!
 * \file QuantTables.cpp
 *
 * \brief Quantization tables
 *
 *
 */

int qtab4x4[128*16] =
{
  16, 17, 16, 17, 17, 18, 17, 18, 16, 17, 16, 17, 17, 18, 17, 18, 
  17, 18, 17, 18, 18, 18, 18, 18, 17, 18, 17, 18, 18, 18, 18, 18, 
  17, 18, 17, 18, 18, 19, 18, 19, 17, 18, 17, 18, 18, 19, 18, 19, 
  18, 19, 18, 19, 19, 20, 19, 20, 18, 19, 18, 19, 19, 20, 19, 20, 
  19, 20, 19, 20, 20, 21, 20, 21, 19, 20, 19, 20, 20, 21, 20, 21, 
  20, 21, 20, 21, 21, 22, 21, 22, 20, 21, 20, 21, 21, 22, 21, 22, 
  21, 22, 21, 22, 22, 23, 22, 23, 21, 22, 21, 22, 22, 23, 22, 23, 
  22, 23, 22, 23, 23, 24, 23, 24, 22, 23, 22, 23, 23, 24, 23, 24, 
  23, 24, 23, 24, 24, 25, 24, 25, 23, 24, 23, 24, 24, 25, 24, 25, 
  24, 25, 24, 25, 25, 26, 25, 26, 24, 25, 24, 25, 25, 26, 25, 26, 
  25, 26, 25, 26, 26, 27, 26, 27, 25, 26, 25, 26, 26, 27, 26, 27, 
  26, 27, 26, 27, 27, 28, 27, 28, 26, 27, 26, 27, 27, 28, 27, 28, 
  27, 28, 27, 28, 28, 30, 28, 30, 27, 28, 27, 28, 28, 30, 28, 30, 
  28, 30, 28, 30, 30, 31, 30, 31, 28, 30, 28, 30, 30, 31, 30, 31, 
  29, 31, 29, 31, 31, 32, 31, 32, 29, 31, 29, 31, 31, 32, 31, 32, 
  31, 32, 31, 32, 32, 34, 32, 34, 31, 32, 31, 32, 32, 34, 32, 34, 
  32, 34, 32, 34, 34, 35, 34, 35, 32, 34, 32, 34, 34, 35, 34, 35, 
  33, 35, 33, 35, 35, 37, 35, 37, 33, 35, 33, 35, 35, 37, 35, 37, 
  35, 37, 35, 37, 37, 39, 37, 39, 35, 37, 35, 37, 37, 39, 37, 39, 
  36, 38, 36, 38, 38, 40, 38, 40, 36, 38, 36, 38, 38, 40, 38, 40, 
  38, 40, 38, 40, 40, 42, 40, 42, 38, 40, 38, 40, 40, 42, 40, 42, 
  40, 42, 40, 42, 42, 44, 42, 44, 40, 42, 40, 42, 42, 44, 42, 44, 
  41, 44, 41, 44, 44, 46, 44, 46, 41, 44, 41, 44, 44, 46, 44, 46, 
  43, 46, 43, 46, 46, 48, 46, 48, 43, 46, 43, 46, 46, 48, 46, 48, 
  45, 48, 45, 48, 48, 50, 48, 50, 45, 48, 45, 48, 48, 50, 48, 50, 
  47, 50, 47, 50, 50, 52, 50, 52, 47, 50, 47, 50, 50, 52, 50, 52, 
  49, 52, 49, 52, 52, 54, 52, 54, 49, 52, 49, 52, 52, 54, 52, 54, 
  52, 54, 52, 54, 54, 57, 54, 57, 52, 54, 52, 54, 54, 57, 54, 57, 
  54, 57, 54, 57, 57, 59, 57, 59, 54, 57, 54, 57, 57, 59, 57, 59, 
  56, 59, 56, 59, 59, 62, 59, 62, 56, 59, 56, 59, 59, 62, 59, 62, 
  59, 62, 59, 62, 62, 65, 62, 65, 59, 62, 59, 62, 62, 65, 62, 65, 
  61, 64, 61, 64, 64, 68, 64, 68, 61, 64, 61, 64, 64, 68, 64, 68, 
  64, 67, 64, 67, 67, 71, 67, 71, 64, 67, 64, 67, 67, 71, 67, 71, 
  67, 70, 67, 70, 70, 74, 70, 74, 67, 70, 67, 70, 70, 74, 70, 74, 
  70, 73, 70, 73, 73, 77, 73, 77, 70, 73, 70, 73, 73, 77, 73, 77, 
  73, 77, 73, 77, 77, 80, 77, 80, 73, 77, 73, 77, 77, 80, 77, 80, 
  76, 80, 76, 80, 80, 84, 80, 84, 76, 80, 76, 80, 80, 84, 80, 84, 
  79, 83, 79, 83, 83, 88, 83, 88, 79, 83, 79, 83, 83, 88, 83, 88, 
  83, 87, 83, 87, 87, 92, 87, 92, 83, 87, 83, 87, 87, 92, 87, 92, 
  87, 91, 87, 91, 91, 96, 91, 96, 87, 91, 87, 91, 91, 96, 91, 96, 
  91, 95, 91, 95, 95, 100, 95, 100, 91, 95, 91, 95, 95, 100, 95, 100, 
  95, 99, 95, 99, 99, 104, 99, 104, 95, 99, 95, 99, 99, 104, 99, 104, 
  99, 104, 99, 104, 104, 109, 104, 109, 99, 104, 99, 104, 104, 109, 104, 109, 
  103, 108, 103, 108, 108, 114, 108, 114, 103, 108, 103, 108, 108, 114, 108, 114, 
  108, 113, 108, 113, 113, 119, 113, 119, 108, 113, 108, 113, 113, 119, 113, 119, 
  112, 118, 112, 118, 118, 124, 118, 124, 112, 118, 112, 118, 118, 124, 118, 124, 
  117, 123, 117, 123, 123, 130, 123, 130, 117, 123, 117, 123, 123, 130, 123, 130, 
  123, 129, 123, 129, 129, 135, 129, 135, 123, 129, 123, 129, 129, 135, 129, 135, 
  128, 134, 128, 134, 134, 141, 134, 141, 128, 134, 128, 134, 134, 141, 134, 141, 
  134, 140, 134, 140, 140, 147, 140, 147, 134, 140, 134, 140, 140, 147, 140, 147, 
  140, 147, 140, 147, 147, 154, 147, 154, 140, 147, 140, 147, 147, 154, 147, 154, 
  146, 153, 146, 153, 153, 161, 153, 161, 146, 153, 146, 153, 153, 161, 153, 161, 
  152, 160, 152, 160, 160, 168, 160, 168, 152, 160, 152, 160, 160, 168, 160, 168, 
  159, 167, 159, 167, 167, 175, 167, 175, 159, 167, 159, 167, 167, 175, 167, 175, 
  166, 174, 166, 174, 174, 183, 174, 183, 166, 174, 166, 174, 174, 183, 174, 183, 
  173, 182, 173, 182, 182, 191, 182, 191, 173, 182, 173, 182, 182, 191, 182, 191, 
  181, 190, 181, 190, 190, 200, 190, 200, 181, 190, 181, 190, 190, 200, 190, 200, 
  189, 199, 189, 199, 199, 209, 199, 209, 189, 199, 189, 199, 199, 209, 199, 209, 
  197, 207, 197, 207, 207, 218, 207, 218, 197, 207, 197, 207, 207, 218, 207, 218, 
  206, 217, 206, 217, 217, 227, 217, 227, 206, 217, 206, 217, 217, 227, 217, 227, 
  215, 226, 215, 226, 226, 238, 226, 238, 215, 226, 215, 226, 226, 238, 226, 238, 
  225, 236, 225, 236, 236, 248, 236, 248, 225, 236, 225, 236, 236, 248, 236, 248, 
  235, 247, 235, 247, 247, 259, 247, 259, 235, 247, 235, 247, 247, 259, 247, 259, 
  245, 258, 245, 258, 258, 271, 258, 271, 245, 258, 245, 258, 258, 271, 258, 271, 
  256, 269, 256, 269, 269, 282, 269, 282, 256, 269, 256, 269, 269, 282, 269, 282, 
  267, 281, 267, 281, 281, 296, 281, 296, 267, 281, 267, 281, 281, 296, 281, 296, 
  279, 293, 279, 293, 293, 308, 293, 308, 279, 293, 279, 293, 293, 308, 293, 308, 
  293, 306, 293, 306, 306, 322, 306, 322, 293, 306, 293, 306, 306, 322, 306, 322, 
  303, 320, 303, 320, 320, 337, 320, 337, 303, 320, 303, 320, 320, 337, 320, 337, 
  318, 333, 318, 333, 333, 352, 333, 352, 318, 333, 318, 333, 333, 352, 333, 352, 
  333, 349, 333, 349, 349, 366, 349, 366, 333, 349, 333, 349, 349, 366, 349, 366, 
  347, 363, 347, 363, 363, 384, 363, 384, 347, 363, 347, 363, 363, 384, 363, 384, 
  362, 381, 362, 381, 381, 399, 381, 399, 362, 381, 362, 381, 381, 399, 381, 399, 
  379, 397, 379, 397, 397, 418, 397, 418, 379, 397, 379, 397, 397, 418, 397, 418, 
  395, 416, 395, 416, 416, 436, 416, 436, 395, 416, 395, 416, 416, 436, 416, 436, 
  412, 433, 412, 433, 433, 456, 433, 456, 412, 433, 412, 433, 433, 456, 433, 456, 
  431, 452, 431, 452, 452, 475, 452, 475, 431, 452, 431, 452, 452, 475, 452, 475, 
  449, 473, 449, 473, 473, 496, 473, 496, 449, 473, 449, 473, 473, 496, 473, 496, 
  471, 492, 471, 492, 492, 518, 492, 518, 471, 492, 471, 492, 492, 518, 492, 518, 
  489, 517, 489, 517, 517, 543, 517, 543, 489, 517, 489, 517, 517, 543, 517, 543, 
  512, 540, 512, 540, 540, 566, 540, 566, 512, 540, 512, 540, 540, 566, 540, 566, 
  537, 561, 537, 561, 561, 591, 561, 591, 537, 561, 537, 561, 561, 591, 561, 591, 
  560, 588, 560, 588, 588, 614, 588, 614, 560, 588, 560, 588, 588, 614, 588, 614, 
  585, 613, 585, 613, 613, 644, 613, 644, 585, 613, 585, 613, 613, 644, 613, 644, 
  607, 640, 607, 640, 640, 671, 640, 671, 607, 640, 607, 640, 640, 671, 640, 671, 
  636, 670, 636, 670, 670, 700, 670, 700, 636, 670, 636, 670, 670, 700, 670, 700, 
  662, 695, 662, 695, 695, 732, 695, 732, 662, 695, 662, 695, 695, 732, 695, 732, 
  690, 730, 690, 730, 730, 767, 730, 767, 690, 730, 690, 730, 730, 767, 730, 767, 
  720, 761, 720, 761, 761, 798, 761, 798, 720, 761, 720, 761, 761, 798, 761, 798, 
  753, 795, 753, 795, 795, 831, 795, 831, 753, 795, 753, 795, 795, 831, 795, 831, 
  790, 831, 790, 831, 831, 867, 831, 867, 790, 831, 790, 831, 831, 867, 831, 867, 
  830, 861, 830, 861, 861, 907, 861, 907, 830, 861, 830, 861, 861, 907, 861, 907, 
  862, 904, 862, 904, 904, 950, 904, 950, 862, 904, 862, 904, 904, 950, 904, 950, 
  898, 939, 898, 939, 939, 997, 939, 997, 898, 939, 898, 939, 939, 997, 939, 997, 
  936, 991, 936, 991, 991, 1036, 991, 1036, 936, 991, 936, 991, 991, 1036, 991, 1036, 
  978, 1033, 978, 1033, 1033, 1078, 1033, 1078, 978, 1033, 978, 1033, 1033, 1078, 1033, 1078, 
  1024, 1079, 1024, 1079, 1079, 1124, 1079, 1124, 1024, 1079, 1024, 1079, 1079, 1124, 1079, 1124, 
  1074, 1130, 1074, 1130, 1130, 1173, 1130, 1173, 1074, 1130, 1074, 1130, 1130, 1173, 1130, 1173, 
  1111, 1166, 1111, 1166, 1166, 1228, 1166, 1228, 1111, 1166, 1111, 1166, 1166, 1228, 1166, 1228, 
  1170, 1226, 1170, 1226, 1226, 1287, 1226, 1287, 1170, 1226, 1170, 1226, 1226, 1287, 1226, 1287, 
  1214, 1269, 1214, 1269, 1269, 1352, 1269, 1352, 1214, 1269, 1214, 1269, 1269, 1352, 1269, 1352, 
  1260, 1339, 1260, 1339, 1339, 1400, 1339, 1400, 1260, 1339, 1260, 1339, 1339, 1400, 1339, 1400, 
  1337, 1391, 1337, 1391, 1391, 1478, 1391, 1478, 1337, 1391, 1337, 1391, 1391, 1478, 1391, 1478, 
  1394, 1446, 1394, 1446, 1446, 1535, 1446, 1535, 1394, 1446, 1394, 1446, 1446, 1535, 1446, 1535, 
  1456, 1507, 1456, 1507, 1507, 1596, 1507, 1596, 1456, 1507, 1456, 1507, 1507, 1596, 1507, 1596, 
  1524, 1572, 1524, 1572, 1572, 1662, 1572, 1662, 1524, 1572, 1524, 1572, 1572, 1662, 1572, 1662, 
  1560, 1644, 1560, 1644, 1644, 1735, 1644, 1735, 1560, 1644, 1560, 1644, 1644, 1735, 1644, 1735, 
  1638, 1722, 1638, 1722, 1722, 1814, 1722, 1814, 1638, 1722, 1638, 1722, 1722, 1814, 1722, 1814, 
  1725, 1808, 1725, 1808, 1808, 1900, 1808, 1900, 1725, 1808, 1725, 1808, 1808, 1900, 1808, 1900, 
  1820, 1903, 1820, 1903, 1903, 1995, 1903, 1995, 1820, 1903, 1820, 1903, 1903, 1995, 1903, 1995, 
  1872, 1954, 1872, 1954, 1954, 2046, 1954, 2046, 1872, 1954, 1872, 1954, 1954, 2046, 1954, 2046, 
  1986, 2066, 1986, 2066, 2066, 2157, 2066, 2157, 1986, 2066, 1986, 2066, 2066, 2157, 2066, 2157, 
  2048, 2127, 2048, 2127, 2127, 2280, 2127, 2280, 2048, 2127, 2048, 2127, 2127, 2280, 2127, 2280, 
  2114, 2260, 2114, 2260, 2260, 2347, 2260, 2347, 2114, 2260, 2114, 2260, 2260, 2347, 2260, 2347, 
  2260, 2333, 2260, 2333, 2333, 2494, 2333, 2494, 2260, 2333, 2260, 2333, 2333, 2494, 2333, 2494, 
  2341, 2411, 2341, 2411, 2411, 2574, 2411, 2574, 2341, 2411, 2341, 2411, 2411, 2574, 2411, 2574, 
  2427, 2583, 2427, 2583, 2583, 2660, 2583, 2660, 2427, 2583, 2427, 2583, 2583, 2660, 2583, 2660, 
  2521, 2678, 2521, 2678, 2678, 2850, 2678, 2850, 2521, 2678, 2521, 2678, 2678, 2850, 2678, 2850, 
  2621, 2781, 2621, 2781, 2781, 2955, 2781, 2955, 2621, 2781, 2621, 2781, 2781, 2955, 2781, 2955, 
  2731, 2893, 2731, 2893, 2893, 3069, 2893, 3069, 2731, 2893, 2731, 2893, 2893, 3069, 2893, 3069, 
  2849, 3013, 2849, 3013, 3013, 3192, 3013, 3192, 2849, 3013, 2849, 3013, 3013, 3192, 3013, 3192, 
  2979, 3144, 2979, 3144, 3144, 3325, 3144, 3325, 2979, 3144, 2979, 3144, 3144, 3325, 3144, 3325, 
  3121, 3287, 3121, 3287, 3287, 3469, 3287, 3469, 3121, 3287, 3121, 3287, 3287, 3469, 3287, 3469, 
  3277, 3444, 3277, 3444, 3444, 3627, 3444, 3627, 3277, 3444, 3277, 3444, 3444, 3627, 3444, 3627, 
  3449, 3616, 3449, 3616, 3616, 3800, 3616, 3800, 3449, 3616, 3449, 3616, 3616, 3800, 3616, 3800, 
  3641, 3806, 3641, 3806, 3806, 3990, 3806, 3990, 3641, 3806, 3641, 3806, 3806, 3990, 3806, 3990, 
  3855, 4018, 3855, 4018, 4018, 4200, 4018, 4200, 3855, 4018, 3855, 4018, 4018, 4200, 4018, 4200, 
  3855, 4018, 3855, 4018, 4018, 4433, 4018, 4433, 3855, 4018, 3855, 4018, 4018, 4433, 4018, 4433, 
};

int qtab2x8[128*16] =
{
  16, 15, 20, 15, 16, 15, 20, 15, 16, 15, 20, 15, 16, 15, 20, 15, 
  17, 16, 21, 16, 17, 16, 21, 16, 17, 16, 21, 16, 17, 16, 21, 16, 
  17, 16, 22, 16, 17, 16, 22, 16, 17, 16, 22, 16, 17, 16, 22, 16, 
  18, 17, 23, 17, 18, 17, 23, 17, 18, 17, 23, 17, 18, 17, 23, 17, 
  19, 18, 24, 18, 19, 18, 24, 18, 19, 18, 24, 18, 19, 18, 24, 18, 
  20, 19, 25, 19, 20, 19, 25, 19, 20, 19, 25, 19, 20, 19, 25, 19, 
  21, 20, 26, 20, 21, 20, 26, 20, 21, 20, 26, 20, 21, 20, 26, 20, 
  22, 20, 27, 20, 22, 20, 27, 20, 22, 20, 27, 20, 22, 20, 27, 20, 
  23, 21, 29, 21, 23, 21, 29, 21, 23, 21, 29, 21, 23, 21, 29, 21, 
  24, 22, 30, 22, 24, 22, 30, 22, 24, 22, 30, 22, 24, 22, 30, 22, 
  25, 23, 31, 23, 25, 23, 31, 23, 25, 23, 31, 23, 25, 23, 31, 23, 
  26, 24, 33, 24, 26, 24, 33, 24, 26, 24, 33, 24, 26, 24, 33, 24, 
  27, 25, 34, 25, 27, 25, 34, 25, 27, 25, 34, 25, 27, 25, 34, 25, 
  28, 26, 36, 26, 28, 26, 36, 26, 28, 26, 36, 26, 28, 26, 36, 26, 
  29, 28, 37, 28, 29, 28, 37, 28, 29, 28, 37, 28, 29, 28, 37, 28, 
  31, 29, 39, 29, 31, 29, 39, 29, 31, 29, 39, 29, 31, 29, 39, 29, 
  32, 30, 40, 30, 32, 30, 40, 30, 32, 30, 40, 30, 32, 30, 40, 30, 
  33, 31, 42, 31, 33, 31, 42, 31, 33, 31, 42, 31, 33, 31, 42, 31, 
  35, 33, 44, 33, 35, 33, 44, 33, 35, 33, 44, 33, 35, 33, 44, 33, 
  36, 34, 46, 34, 36, 34, 46, 34, 36, 34, 46, 34, 36, 34, 46, 34, 
  38, 36, 48, 36, 38, 36, 48, 36, 38, 36, 48, 36, 38, 36, 48, 36, 
  40, 37, 50, 37, 40, 37, 50, 37, 40, 37, 50, 37, 40, 37, 50, 37, 
  41, 39, 52, 39, 41, 39, 52, 39, 41, 39, 52, 39, 41, 39, 52, 39, 
  43, 41, 55, 41, 43, 41, 55, 41, 43, 41, 55, 41, 43, 41, 55, 41, 
  45, 43, 57, 43, 45, 43, 57, 43, 45, 43, 57, 43, 45, 43, 57, 43, 
  47, 44, 60, 44, 47, 44, 60, 44, 47, 44, 60, 44, 47, 44, 60, 44, 
  49, 46, 62, 46, 49, 46, 62, 46, 49, 46, 62, 46, 49, 46, 62, 46, 
  52, 49, 65, 49, 52, 49, 65, 49, 52, 49, 65, 49, 52, 49, 65, 49, 
  54, 51, 68, 51, 54, 51, 68, 51, 54, 51, 68, 51, 54, 51, 68, 51, 
  56, 53, 71, 53, 56, 53, 71, 53, 56, 53, 71, 53, 56, 53, 71, 53, 
  59, 55, 74, 55, 59, 55, 74, 55, 59, 55, 74, 55, 59, 55, 74, 55, 
  61, 58, 78, 58, 61, 58, 78, 58, 61, 58, 78, 58, 61, 58, 78, 58, 
  64, 60, 81, 60, 64, 60, 81, 60, 64, 60, 81, 60, 64, 60, 81, 60, 
  67, 63, 85, 63, 67, 63, 85, 63, 67, 63, 85, 63, 67, 63, 85, 63, 
  70, 66, 88, 66, 70, 66, 88, 66, 70, 66, 88, 66, 70, 66, 88, 66, 
  73, 69, 92, 69, 73, 69, 92, 69, 73, 69, 92, 69, 73, 69, 92, 69, 
  76, 72, 96, 72, 76, 72, 96, 72, 76, 72, 96, 72, 76, 72, 96, 72, 
  79, 75, 101, 75, 79, 75, 101, 75, 79, 75, 101, 75, 79, 75, 101, 75, 
  83, 78, 105, 78, 83, 78, 105, 78, 83, 78, 105, 78, 83, 78, 105, 78, 
  87, 82, 110, 82, 87, 82, 110, 82, 87, 82, 110, 82, 87, 82, 110, 82, 
  91, 85, 114, 85, 91, 85, 114, 85, 91, 85, 114, 85, 91, 85, 114, 85, 
  95, 89, 120, 89, 95, 89, 120, 89, 95, 89, 120, 89, 95, 89, 120, 89, 
  99, 93, 125, 93, 99, 93, 125, 93, 99, 93, 125, 93, 99, 93, 125, 93, 
  103, 97, 130, 97, 103, 97, 130, 97, 103, 97, 130, 97, 103, 97, 130, 97, 
  108, 101, 136, 101, 108, 101, 136, 101, 108, 101, 136, 101, 108, 101, 136, 101, 
  112, 106, 142, 106, 112, 106, 142, 106, 112, 106, 142, 106, 112, 106, 142, 106, 
  117, 110, 148, 110, 117, 110, 148, 110, 117, 110, 148, 110, 117, 110, 148, 110, 
  123, 115, 155, 115, 123, 115, 155, 115, 123, 115, 155, 115, 123, 115, 155, 115, 
  128, 120, 162, 120, 128, 120, 162, 120, 128, 120, 162, 120, 128, 120, 162, 120, 
  134, 126, 169, 126, 134, 126, 169, 126, 134, 126, 169, 126, 134, 126, 169, 126, 
  140, 131, 177, 131, 140, 131, 177, 131, 140, 131, 177, 131, 140, 131, 177, 131, 
  146, 137, 184, 137, 146, 137, 184, 137, 146, 137, 184, 137, 146, 137, 184, 137, 
  152, 143, 193, 143, 152, 143, 193, 143, 152, 143, 193, 143, 152, 143, 193, 143, 
  159, 150, 201, 150, 159, 150, 201, 150, 159, 150, 201, 150, 159, 150, 201, 150, 
  166, 156, 210, 156, 166, 156, 210, 156, 166, 156, 210, 156, 166, 156, 210, 156, 
  173, 163, 219, 163, 173, 163, 219, 163, 173, 163, 219, 163, 173, 163, 219, 163, 
  181, 170, 229, 170, 181, 170, 229, 170, 181, 170, 229, 170, 181, 170, 229, 170, 
  189, 178, 239, 178, 189, 178, 239, 178, 189, 178, 239, 178, 189, 178, 239, 178, 
  197, 186, 250, 186, 197, 186, 250, 186, 197, 186, 250, 186, 197, 186, 250, 186, 
  206, 194, 261, 194, 206, 194, 261, 194, 206, 194, 261, 194, 206, 194, 261, 194, 
  215, 203, 272, 203, 215, 203, 272, 203, 215, 203, 272, 203, 215, 203, 272, 203, 
  225, 212, 284, 212, 225, 212, 284, 212, 225, 212, 284, 212, 225, 212, 284, 212, 
  235, 221, 297, 221, 235, 221, 297, 221, 235, 221, 297, 221, 235, 221, 297, 221, 
  245, 231, 310, 231, 245, 231, 310, 231, 245, 231, 310, 231, 245, 231, 310, 231, 
  256, 241, 324, 241, 256, 241, 324, 241, 256, 241, 324, 241, 256, 241, 324, 241, 
  267, 252, 338, 252, 267, 252, 338, 252, 267, 252, 338, 252, 267, 252, 338, 252, 
  279, 263, 353, 263, 279, 263, 353, 263, 279, 263, 353, 263, 279, 263, 353, 263, 
  293, 274, 369, 274, 293, 274, 369, 274, 293, 274, 369, 274, 293, 274, 369, 274, 
  303, 287, 386, 287, 303, 287, 386, 287, 303, 287, 386, 287, 303, 287, 386, 287, 
  318, 299, 402, 299, 318, 299, 402, 299, 318, 299, 402, 299, 318, 299, 402, 299, 
  333, 312, 419, 312, 333, 312, 419, 312, 333, 312, 419, 312, 333, 312, 419, 312, 
  347, 326, 439, 326, 347, 326, 439, 326, 347, 326, 439, 326, 347, 326, 439, 326, 
  362, 341, 458, 341, 362, 341, 458, 341, 362, 341, 458, 341, 362, 341, 458, 341, 
  379, 356, 479, 356, 379, 356, 479, 356, 379, 356, 479, 356, 379, 356, 479, 356, 
  395, 372, 499, 372, 395, 372, 499, 372, 395, 372, 499, 372, 395, 372, 499, 372, 
  412, 387, 522, 387, 412, 387, 522, 387, 412, 387, 522, 387, 412, 387, 522, 387, 
  431, 406, 546, 406, 431, 406, 546, 406, 431, 406, 546, 406, 431, 406, 546, 406, 
  449, 424, 570, 424, 449, 424, 570, 424, 449, 424, 570, 424, 449, 424, 570, 424, 
  471, 443, 592, 443, 471, 443, 592, 443, 471, 443, 592, 443, 471, 443, 592, 443, 
  489, 461, 620, 461, 489, 461, 620, 461, 489, 461, 620, 461, 489, 461, 620, 461, 
  512, 484, 647, 484, 512, 484, 647, 484, 512, 484, 647, 484, 512, 484, 647, 484, 
  537, 505, 677, 505, 537, 505, 677, 505, 537, 505, 677, 505, 537, 505, 677, 505, 
  560, 523, 704, 523, 560, 523, 704, 523, 560, 523, 704, 523, 560, 523, 704, 523, 
  585, 548, 738, 548, 585, 548, 738, 548, 585, 548, 738, 548, 585, 548, 738, 548, 
  607, 575, 771, 575, 607, 575, 771, 575, 607, 575, 771, 575, 607, 575, 771, 575, 
  636, 598, 807, 598, 636, 598, 807, 598, 636, 598, 807, 598, 636, 598, 807, 598, 
  662, 624, 839, 624, 662, 624, 839, 624, 662, 624, 839, 624, 662, 624, 839, 624, 
  690, 652, 874, 652, 690, 652, 874, 652, 690, 652, 874, 652, 690, 652, 874, 652, 
  720, 683, 920, 683, 720, 683, 920, 683, 720, 683, 920, 683, 720, 683, 920, 683, 
  753, 708, 953, 708, 753, 708, 953, 708, 753, 708, 953, 708, 753, 708, 953, 708, 
  790, 744, 999, 744, 790, 744, 999, 744, 790, 744, 999, 744, 790, 744, 999, 744, 
  830, 774, 1038, 774, 830, 774, 1038, 774, 830, 774, 1038, 774, 830, 774, 1038, 774, 
  862, 806, 1092, 806, 862, 806, 1092, 806, 862, 806, 1092, 806, 862, 806, 1092, 806, 
  898, 841, 1140, 841, 898, 841, 1140, 841, 898, 841, 1140, 841, 898, 841, 1140, 841, 
  936, 880, 1192, 880, 936, 880, 1192, 880, 936, 880, 1192, 880, 936, 880, 1192, 880, 
  978, 921, 1234, 921, 978, 921, 1234, 921, 978, 921, 1234, 921, 978, 921, 1234, 921, 
  1024, 968, 1295, 968, 1024, 968, 1295, 968, 1024, 968, 1295, 968, 1024, 968, 1295, 968, 
  1074, 1001, 1344, 1001, 1074, 1001, 1344, 1001, 1074, 1001, 1344, 1001, 1074, 1001, 1344, 1001, 
  1111, 1056, 1417, 1056, 1111, 1056, 1417, 1056, 1111, 1056, 1417, 1056, 1111, 1056, 1417, 1056, 
  1170, 1095, 1477, 1095, 1170, 1095, 1477, 1095, 1170, 1095, 1477, 1095, 1170, 1095, 1477, 1095, 
  1214, 1138, 1542, 1138, 1214, 1138, 1542, 1138, 1214, 1138, 1542, 1138, 1214, 1138, 1542, 1138, 
  1260, 1209, 1613, 1209, 1260, 1209, 1613, 1209, 1260, 1209, 1613, 1209, 1260, 1209, 1613, 1209, 
  1337, 1262, 1691, 1262, 1337, 1262, 1691, 1262, 1337, 1262, 1691, 1262, 1337, 1262, 1691, 1262, 
  1394, 1319, 1748, 1319, 1394, 1319, 1748, 1319, 1394, 1319, 1748, 1319, 1394, 1319, 1748, 1319, 
  1456, 1350, 1840, 1350, 1456, 1350, 1840, 1350, 1456, 1350, 1840, 1350, 1456, 1350, 1840, 1350, 
  1524, 1416, 1907, 1416, 1524, 1416, 1907, 1416, 1524, 1416, 1907, 1416, 1524, 1416, 1907, 1416, 
  1560, 1489, 2016, 1489, 1560, 1489, 2016, 1489, 1560, 1489, 2016, 1489, 1560, 1489, 2016, 1489, 
  1638, 1569, 2097, 1569, 1638, 1569, 2097, 1569, 1638, 1569, 2097, 1569, 1638, 1569, 2097, 1569, 
  1725, 1613, 2185, 1613, 1725, 1613, 2185, 1613, 1725, 1613, 2185, 1613, 1725, 1613, 2185, 1613, 
  1820, 1707, 2280, 1707, 1820, 1707, 2280, 1707, 1820, 1707, 2280, 1707, 1820, 1707, 2280, 1707, 
  1872, 1759, 2383, 1759, 1872, 1759, 2383, 1759, 1872, 1759, 2383, 1759, 1872, 1759, 2383, 1759, 
  1986, 1873, 2497, 1873, 1986, 1873, 2497, 1873, 1986, 1873, 2497, 1873, 1986, 1873, 2497, 1873, 
  2048, 1935, 2621, 1935, 2048, 1935, 2621, 1935, 2048, 1935, 2621, 1935, 2048, 1935, 2621, 1935, 
  2114, 2002, 2689, 2002, 2114, 2002, 2689, 2002, 2114, 2002, 2689, 2002, 2114, 2002, 2689, 2002, 
  2260, 2073, 2834, 2073, 2260, 2073, 2834, 2073, 2260, 2073, 2834, 2073, 2260, 2073, 2834, 2073, 
  2341, 2233, 2913, 2233, 2341, 2233, 2913, 2233, 2341, 2233, 2913, 2233, 2341, 2233, 2913, 2233, 
  2427, 2322, 3084, 2322, 2427, 2322, 3084, 2322, 2427, 2322, 3084, 2322, 2427, 2322, 3084, 2322, 
  2521, 2419, 3178, 2419, 2521, 2419, 3178, 2419, 2521, 2419, 3178, 2419, 2521, 2419, 3178, 2419, 
  2621, 2524, 3383, 2524, 2621, 2524, 3383, 2524, 2621, 2524, 3383, 2524, 2621, 2524, 3383, 2524, 
  2731, 2639, 3495, 2639, 2731, 2639, 3495, 2639, 2731, 2639, 3495, 2639, 2731, 2639, 3495, 2639, 
  2849, 2764, 3616, 2764, 2849, 2764, 3616, 2764, 2849, 2764, 3616, 2764, 2849, 2764, 3616, 2764, 
  2979, 2903, 3884, 2903, 2979, 2903, 3884, 2903, 2979, 2903, 3884, 2903, 2979, 2903, 3884, 2903, 
  3121, 2903, 4033, 2903, 3121, 2903, 4033, 2903, 3121, 2903, 4033, 2903, 3121, 2903, 4033, 2903, 
  3277, 3055, 4194, 3055, 3277, 3055, 4194, 3055, 3277, 3055, 4194, 3055, 3277, 3055, 4194, 3055, 
  3449, 3225, 4369, 3225, 3449, 3225, 4369, 3225, 3449, 3225, 4369, 3225, 3449, 3225, 4369, 3225, 
  3641, 3415, 4559, 3415, 3641, 3415, 4559, 3415, 3641, 3415, 4559, 3415, 3641, 3415, 4559, 3415, 
  3855, 3628, 4766, 3628, 3855, 3628, 4766, 3628, 3855, 3628, 4766, 3628, 3855, 3628, 4766, 3628, 
  3855, 3628, 4993, 3628, 3855, 3628, 4993, 3628, 3855, 3628, 4993, 3628, 3855, 3628, 4993, 3628, 
};

int qtab8x2[128*16] =
{
  16, 16, 15, 15, 20, 20, 15, 15, 16, 16, 15, 15, 20, 20, 15, 15, 
  17, 17, 16, 16, 21, 21, 16, 16, 17, 17, 16, 16, 21, 21, 16, 16, 
  17, 17, 16, 16, 22, 22, 16, 16, 17, 17, 16, 16, 22, 22, 16, 16, 
  18, 18, 17, 17, 23, 23, 17, 17, 18, 18, 17, 17, 23, 23, 17, 17, 
  19, 19, 18, 18, 24, 24, 18, 18, 19, 19, 18, 18, 24, 24, 18, 18, 
  20, 20, 19, 19, 25, 25, 19, 19, 20, 20, 19, 19, 25, 25, 19, 19, 
  21, 21, 20, 20, 26, 26, 20, 20, 21, 21, 20, 20, 26, 26, 20, 20, 
  22, 22, 20, 20, 27, 27, 20, 20, 22, 22, 20, 20, 27, 27, 20, 20, 
  23, 23, 21, 21, 29, 29, 21, 21, 23, 23, 21, 21, 29, 29, 21, 21, 
  24, 24, 22, 22, 30, 30, 22, 22, 24, 24, 22, 22, 30, 30, 22, 22, 
  25, 25, 23, 23, 31, 31, 23, 23, 25, 25, 23, 23, 31, 31, 23, 23, 
  26, 26, 24, 24, 33, 33, 24, 24, 26, 26, 24, 24, 33, 33, 24, 24, 
  27, 27, 25, 25, 34, 34, 25, 25, 27, 27, 25, 25, 34, 34, 25, 25, 
  28, 28, 26, 26, 36, 36, 26, 26, 28, 28, 26, 26, 36, 36, 26, 26, 
  29, 29, 28, 28, 37, 37, 28, 28, 29, 29, 28, 28, 37, 37, 28, 28, 
  31, 31, 29, 29, 39, 39, 29, 29, 31, 31, 29, 29, 39, 39, 29, 29, 
  32, 32, 30, 30, 40, 40, 30, 30, 32, 32, 30, 30, 40, 40, 30, 30, 
  33, 33, 31, 31, 42, 42, 31, 31, 33, 33, 31, 31, 42, 42, 31, 31, 
  35, 35, 33, 33, 44, 44, 33, 33, 35, 35, 33, 33, 44, 44, 33, 33, 
  36, 36, 34, 34, 46, 46, 34, 34, 36, 36, 34, 34, 46, 46, 34, 34, 
  38, 38, 36, 36, 48, 48, 36, 36, 38, 38, 36, 36, 48, 48, 36, 36, 
  40, 40, 37, 37, 50, 50, 37, 37, 40, 40, 37, 37, 50, 50, 37, 37, 
  41, 41, 39, 39, 52, 52, 39, 39, 41, 41, 39, 39, 52, 52, 39, 39, 
  43, 43, 41, 41, 55, 55, 41, 41, 43, 43, 41, 41, 55, 55, 41, 41, 
  45, 45, 43, 43, 57, 57, 43, 43, 45, 45, 43, 43, 57, 57, 43, 43, 
  47, 47, 44, 44, 60, 60, 44, 44, 47, 47, 44, 44, 60, 60, 44, 44, 
  49, 49, 46, 46, 62, 62, 46, 46, 49, 49, 46, 46, 62, 62, 46, 46, 
  52, 52, 49, 49, 65, 65, 49, 49, 52, 52, 49, 49, 65, 65, 49, 49, 
  54, 54, 51, 51, 68, 68, 51, 51, 54, 54, 51, 51, 68, 68, 51, 51, 
  56, 56, 53, 53, 71, 71, 53, 53, 56, 56, 53, 53, 71, 71, 53, 53, 
  59, 59, 55, 55, 74, 74, 55, 55, 59, 59, 55, 55, 74, 74, 55, 55, 
  61, 61, 58, 58, 78, 78, 58, 58, 61, 61, 58, 58, 78, 78, 58, 58, 
  64, 64, 60, 60, 81, 81, 60, 60, 64, 64, 60, 60, 81, 81, 60, 60, 
  67, 67, 63, 63, 85, 85, 63, 63, 67, 67, 63, 63, 85, 85, 63, 63, 
  70, 70, 66, 66, 88, 88, 66, 66, 70, 70, 66, 66, 88, 88, 66, 66, 
  73, 73, 69, 69, 92, 92, 69, 69, 73, 73, 69, 69, 92, 92, 69, 69, 
  76, 76, 72, 72, 96, 96, 72, 72, 76, 76, 72, 72, 96, 96, 72, 72, 
  79, 79, 75, 75, 101, 101, 75, 75, 79, 79, 75, 75, 101, 101, 75, 75, 
  83, 83, 78, 78, 105, 105, 78, 78, 83, 83, 78, 78, 105, 105, 78, 78, 
  87, 87, 82, 82, 110, 110, 82, 82, 87, 87, 82, 82, 110, 110, 82, 82, 
  91, 91, 85, 85, 114, 114, 85, 85, 91, 91, 85, 85, 114, 114, 85, 85, 
  95, 95, 89, 89, 120, 120, 89, 89, 95, 95, 89, 89, 120, 120, 89, 89, 
  99, 99, 93, 93, 125, 125, 93, 93, 99, 99, 93, 93, 125, 125, 93, 93, 
  103, 103, 97, 97, 130, 130, 97, 97, 103, 103, 97, 97, 130, 130, 97, 97, 
  108, 108, 101, 101, 136, 136, 101, 101, 108, 108, 101, 101, 136, 136, 101, 101, 
  112, 112, 106, 106, 142, 142, 106, 106, 112, 112, 106, 106, 142, 142, 106, 106, 
  117, 117, 110, 110, 148, 148, 110, 110, 117, 117, 110, 110, 148, 148, 110, 110, 
  123, 123, 115, 115, 155, 155, 115, 115, 123, 123, 115, 115, 155, 155, 115, 115, 
  128, 128, 120, 120, 162, 162, 120, 120, 128, 128, 120, 120, 162, 162, 120, 120, 
  134, 134, 126, 126, 169, 169, 126, 126, 134, 134, 126, 126, 169, 169, 126, 126, 
  140, 140, 131, 131, 177, 177, 131, 131, 140, 140, 131, 131, 177, 177, 131, 131, 
  146, 146, 137, 137, 184, 184, 137, 137, 146, 146, 137, 137, 184, 184, 137, 137, 
  152, 152, 143, 143, 193, 193, 143, 143, 152, 152, 143, 143, 193, 193, 143, 143, 
  159, 159, 150, 150, 201, 201, 150, 150, 159, 159, 150, 150, 201, 201, 150, 150, 
  166, 166, 156, 156, 210, 210, 156, 156, 166, 166, 156, 156, 210, 210, 156, 156, 
  173, 173, 163, 163, 219, 219, 163, 163, 173, 173, 163, 163, 219, 219, 163, 163, 
  181, 181, 170, 170, 229, 229, 170, 170, 181, 181, 170, 170, 229, 229, 170, 170, 
  189, 189, 178, 178, 239, 239, 178, 178, 189, 189, 178, 178, 239, 239, 178, 178, 
  197, 197, 186, 186, 250, 250, 186, 186, 197, 197, 186, 186, 250, 250, 186, 186, 
  206, 206, 194, 194, 261, 261, 194, 194, 206, 206, 194, 194, 261, 261, 194, 194, 
  215, 215, 203, 203, 272, 272, 203, 203, 215, 215, 203, 203, 272, 272, 203, 203, 
  225, 225, 212, 212, 284, 284, 212, 212, 225, 225, 212, 212, 284, 284, 212, 212, 
  235, 235, 221, 221, 297, 297, 221, 221, 235, 235, 221, 221, 297, 297, 221, 221, 
  245, 245, 231, 231, 310, 310, 231, 231, 245, 245, 231, 231, 310, 310, 231, 231, 
  256, 256, 241, 241, 324, 324, 241, 241, 256, 256, 241, 241, 324, 324, 241, 241, 
  267, 267, 252, 252, 338, 338, 252, 252, 267, 267, 252, 252, 338, 338, 252, 252, 
  279, 279, 263, 263, 353, 353, 263, 263, 279, 279, 263, 263, 353, 353, 263, 263, 
  293, 293, 274, 274, 369, 369, 274, 274, 293, 293, 274, 274, 369, 369, 274, 274, 
  303, 303, 287, 287, 386, 386, 287, 287, 303, 303, 287, 287, 386, 386, 287, 287, 
  318, 318, 299, 299, 402, 402, 299, 299, 318, 318, 299, 299, 402, 402, 299, 299, 
  333, 333, 312, 312, 419, 419, 312, 312, 333, 333, 312, 312, 419, 419, 312, 312, 
  347, 347, 326, 326, 439, 439, 326, 326, 347, 347, 326, 326, 439, 439, 326, 326, 
  362, 362, 341, 341, 458, 458, 341, 341, 362, 362, 341, 341, 458, 458, 341, 341, 
  379, 379, 356, 356, 479, 479, 356, 356, 379, 379, 356, 356, 479, 479, 356, 356, 
  395, 395, 372, 372, 499, 499, 372, 372, 395, 395, 372, 372, 499, 499, 372, 372, 
  412, 412, 387, 387, 522, 522, 387, 387, 412, 412, 387, 387, 522, 522, 387, 387, 
  431, 431, 406, 406, 546, 546, 406, 406, 431, 431, 406, 406, 546, 546, 406, 406, 
  449, 449, 424, 424, 570, 570, 424, 424, 449, 449, 424, 424, 570, 570, 424, 424, 
  471, 471, 443, 443, 592, 592, 443, 443, 471, 471, 443, 443, 592, 592, 443, 443, 
  489, 489, 461, 461, 620, 620, 461, 461, 489, 489, 461, 461, 620, 620, 461, 461, 
  512, 512, 484, 484, 647, 647, 484, 484, 512, 512, 484, 484, 647, 647, 484, 484, 
  537, 537, 505, 505, 677, 677, 505, 505, 537, 537, 505, 505, 677, 677, 505, 505, 
  560, 560, 523, 523, 704, 704, 523, 523, 560, 560, 523, 523, 704, 704, 523, 523, 
  585, 585, 548, 548, 738, 738, 548, 548, 585, 585, 548, 548, 738, 738, 548, 548, 
  607, 607, 575, 575, 771, 771, 575, 575, 607, 607, 575, 575, 771, 771, 575, 575, 
  636, 636, 598, 598, 807, 807, 598, 598, 636, 636, 598, 598, 807, 807, 598, 598, 
  662, 662, 624, 624, 839, 839, 624, 624, 662, 662, 624, 624, 839, 839, 624, 624, 
  690, 690, 652, 652, 874, 874, 652, 652, 690, 690, 652, 652, 874, 874, 652, 652, 
  720, 720, 683, 683, 920, 920, 683, 683, 720, 720, 683, 683, 920, 920, 683, 683, 
  753, 753, 708, 708, 953, 953, 708, 708, 753, 753, 708, 708, 953, 953, 708, 708, 
  790, 790, 744, 744, 999, 999, 744, 744, 790, 790, 744, 744, 999, 999, 744, 744, 
  830, 830, 774, 774, 1038, 1038, 774, 774, 830, 830, 774, 774, 1038, 1038, 774, 774, 
  862, 862, 806, 806, 1092, 1092, 806, 806, 862, 862, 806, 806, 1092, 1092, 806, 806, 
  898, 898, 841, 841, 1140, 1140, 841, 841, 898, 898, 841, 841, 1140, 1140, 841, 841, 
  936, 936, 880, 880, 1192, 1192, 880, 880, 936, 936, 880, 880, 1192, 1192, 880, 880, 
  978, 978, 921, 921, 1234, 1234, 921, 921, 978, 978, 921, 921, 1234, 1234, 921, 921, 
  1024, 1024, 968, 968, 1295, 1295, 968, 968, 1024, 1024, 968, 968, 1295, 1295, 968, 968, 
  1074, 1074, 1001, 1001, 1344, 1344, 1001, 1001, 1074, 1074, 1001, 1001, 1344, 1344, 1001, 1001, 
  1111, 1111, 1056, 1056, 1417, 1417, 1056, 1056, 1111, 1111, 1056, 1056, 1417, 1417, 1056, 1056, 
  1170, 1170, 1095, 1095, 1477, 1477, 1095, 1095, 1170, 1170, 1095, 1095, 1477, 1477, 1095, 1095, 
  1214, 1214, 1138, 1138, 1542, 1542, 1138, 1138, 1214, 1214, 1138, 1138, 1542, 1542, 1138, 1138, 
  1260, 1260, 1209, 1209, 1613, 1613, 1209, 1209, 1260, 1260, 1209, 1209, 1613, 1613, 1209, 1209, 
  1337, 1337, 1262, 1262, 1691, 1691, 1262, 1262, 1337, 1337, 1262, 1262, 1691, 1691, 1262, 1262, 
  1394, 1394, 1319, 1319, 1748, 1748, 1319, 1319, 1394, 1394, 1319, 1319, 1748, 1748, 1319, 1319, 
  1456, 1456, 1350, 1350, 1840, 1840, 1350, 1350, 1456, 1456, 1350, 1350, 1840, 1840, 1350, 1350, 
  1524, 1524, 1416, 1416, 1907, 1907, 1416, 1416, 1524, 1524, 1416, 1416, 1907, 1907, 1416, 1416, 
  1560, 1560, 1489, 1489, 2016, 2016, 1489, 1489, 1560, 1560, 1489, 1489, 2016, 2016, 1489, 1489, 
  1638, 1638, 1569, 1569, 2097, 2097, 1569, 1569, 1638, 1638, 1569, 1569, 2097, 2097, 1569, 1569, 
  1725, 1725, 1613, 1613, 2185, 2185, 1613, 1613, 1725, 1725, 1613, 1613, 2185, 2185, 1613, 1613, 
  1820, 1820, 1707, 1707, 2280, 2280, 1707, 1707, 1820, 1820, 1707, 1707, 2280, 2280, 1707, 1707, 
  1872, 1872, 1759, 1759, 2383, 2383, 1759, 1759, 1872, 1872, 1759, 1759, 2383, 2383, 1759, 1759, 
  1986, 1986, 1873, 1873, 2497, 2497, 1873, 1873, 1986, 1986, 1873, 1873, 2497, 2497, 1873, 1873, 
  2048, 2048, 1935, 1935, 2621, 2621, 1935, 1935, 2048, 2048, 1935, 1935, 2621, 2621, 1935, 1935, 
  2114, 2114, 2002, 2002, 2689, 2689, 2002, 2002, 2114, 2114, 2002, 2002, 2689, 2689, 2002, 2002, 
  2260, 2260, 2073, 2073, 2834, 2834, 2073, 2073, 2260, 2260, 2073, 2073, 2834, 2834, 2073, 2073, 
  2341, 2341, 2233, 2233, 2913, 2913, 2233, 2233, 2341, 2341, 2233, 2233, 2913, 2913, 2233, 2233, 
  2427, 2427, 2322, 2322, 3084, 3084, 2322, 2322, 2427, 2427, 2322, 2322, 3084, 3084, 2322, 2322, 
  2521, 2521, 2419, 2419, 3178, 3178, 2419, 2419, 2521, 2521, 2419, 2419, 3178, 3178, 2419, 2419, 
  2621, 2621, 2524, 2524, 3383, 3383, 2524, 2524, 2621, 2621, 2524, 2524, 3383, 3383, 2524, 2524, 
  2731, 2731, 2639, 2639, 3495, 3495, 2639, 2639, 2731, 2731, 2639, 2639, 3495, 3495, 2639, 2639, 
  2849, 2849, 2764, 2764, 3616, 3616, 2764, 2764, 2849, 2849, 2764, 2764, 3616, 3616, 2764, 2764, 
  2979, 2979, 2903, 2903, 3884, 3884, 2903, 2903, 2979, 2979, 2903, 2903, 3884, 3884, 2903, 2903, 
  3121, 3121, 2903, 2903, 4033, 4033, 2903, 2903, 3121, 3121, 2903, 2903, 4033, 4033, 2903, 2903, 
  3277, 3277, 3055, 3055, 4194, 4194, 3055, 3055, 3277, 3277, 3055, 3055, 4194, 4194, 3055, 3055, 
  3449, 3449, 3225, 3225, 4369, 4369, 3225, 3225, 3449, 3449, 3225, 3225, 4369, 4369, 3225, 3225, 
  3641, 3641, 3415, 3415, 4559, 4559, 3415, 3415, 3641, 3641, 3415, 3415, 4559, 4559, 3415, 3415, 
  3855, 3855, 3628, 3628, 4766, 4766, 3628, 3628, 3855, 3855, 3628, 3628, 4766, 4766, 3628, 3628, 
  3855, 3855, 3628, 3628, 4993, 4993, 3628, 3628, 3855, 3855, 3628, 3628, 4993, 4993, 3628, 3628, 
};

int qtab8x8[128 * 64] = 
{
  8, 8, 10, 8, 8, 8, 10, 8, 8, 7, 10, 7, 8, 7, 10, 7, 10, 10, 13, 10, 10, 10, 13, 10, 8, 7, 10, 7, 8, 7, 10, 7, 8, 8, 10, 8, 8, 8, 10, 8, 8, 7, 10, 7, 8, 7, 10, 7, 10, 10, 13, 10, 10, 10, 13, 10, 8, 7, 10, 7, 8, 7, 10, 7, 
  8, 8, 11, 8, 8, 8, 11, 8, 8, 7, 10, 7, 8, 7, 10, 7, 11, 10, 13, 10, 11, 10, 13, 10, 8, 7, 10, 7, 8, 7, 10, 7, 8, 8, 11, 8, 8, 8, 11, 8, 8, 7, 10, 7, 8, 7, 10, 7, 11, 10, 13, 10, 11, 10, 13, 10, 8, 7, 10, 7, 8, 7, 10, 7, 
  9, 8, 11, 8, 9, 8, 11, 8, 8, 8, 10, 8, 8, 8, 10, 8, 11, 10, 14, 10, 11, 10, 14, 10, 8, 8, 10, 8, 8, 8, 10, 8, 9, 8, 11, 8, 9, 8, 11, 8, 8, 8, 10, 8, 8, 8, 10, 8, 11, 10, 14, 10, 11, 10, 14, 10, 8, 8, 10, 8, 8, 8, 10, 8, 
  9, 9, 12, 9, 9, 9, 12, 9, 9, 8, 11, 8, 9, 8, 11, 8, 12, 11, 15, 11, 12, 11, 15, 11, 9, 8, 11, 8, 9, 8, 11, 8, 9, 9, 12, 9, 9, 9, 12, 9, 9, 8, 11, 8, 9, 8, 11, 8, 12, 11, 15, 11, 12, 11, 15, 11, 9, 8, 11, 8, 9, 8, 11, 8, 
  10, 9, 12, 9, 10, 9, 12, 9, 9, 8, 11, 8, 9, 8, 11, 8, 12, 11, 15, 11, 12, 11, 15, 11, 9, 8, 11, 8, 9, 8, 11, 8, 10, 9, 12, 9, 10, 9, 12, 9, 9, 8, 11, 8, 9, 8, 11, 8, 12, 11, 15, 11, 12, 11, 15, 11, 9, 8, 11, 8, 9, 8, 11, 8, 
  10, 9, 13, 9, 10, 9, 13, 9, 9, 9, 12, 9, 9, 9, 12, 9, 13, 12, 16, 12, 13, 12, 16, 12, 9, 9, 12, 9, 9, 9, 12, 9, 10, 9, 13, 9, 10, 9, 13, 9, 9, 9, 12, 9, 9, 9, 12, 9, 13, 12, 16, 12, 13, 12, 16, 12, 9, 9, 12, 9, 9, 9, 12, 9, 
  10, 10, 13, 10, 10, 10, 13, 10, 10, 9, 12, 9, 10, 9, 12, 9, 13, 12, 17, 12, 13, 12, 17, 12, 10, 9, 12, 9, 10, 9, 12, 9, 10, 10, 13, 10, 10, 10, 13, 10, 10, 9, 12, 9, 10, 9, 12, 9, 13, 12, 17, 12, 13, 12, 17, 12, 10, 9, 12, 9, 10, 9, 12, 9, 
  11, 10, 14, 10, 11, 10, 14, 10, 10, 10, 13, 10, 10, 10, 13, 10, 14, 13, 17, 13, 14, 13, 17, 13, 10, 10, 13, 10, 10, 10, 13, 10, 11, 10, 14, 10, 11, 10, 14, 10, 10, 10, 13, 10, 10, 10, 13, 10, 14, 13, 17, 13, 14, 13, 17, 13, 10, 10, 13, 10, 10, 10, 13, 10, 
  11, 11, 14, 11, 11, 11, 14, 11, 11, 10, 13, 10, 11, 10, 13, 10, 14, 13, 18, 13, 14, 13, 18, 13, 11, 10, 13, 10, 11, 10, 13, 10, 11, 11, 14, 11, 11, 11, 14, 11, 11, 10, 13, 10, 11, 10, 13, 10, 14, 13, 18, 13, 14, 13, 18, 13, 11, 10, 13, 10, 11, 10, 13, 10, 
  12, 11, 15, 11, 12, 11, 15, 11, 11, 10, 14, 10, 11, 10, 14, 10, 15, 14, 19, 14, 15, 14, 19, 14, 11, 10, 14, 10, 11, 10, 14, 10, 12, 11, 15, 11, 12, 11, 15, 11, 11, 10, 14, 10, 11, 10, 14, 10, 15, 14, 19, 14, 15, 14, 19, 14, 11, 10, 14, 10, 11, 10, 14, 10, 
  12, 12, 16, 12, 12, 12, 16, 12, 12, 11, 15, 11, 12, 11, 15, 11, 16, 15, 20, 15, 16, 15, 20, 15, 12, 11, 15, 11, 12, 11, 15, 11, 12, 12, 16, 12, 12, 12, 16, 12, 12, 11, 15, 11, 12, 11, 15, 11, 16, 15, 20, 15, 16, 15, 20, 15, 12, 11, 15, 11, 12, 11, 15, 11, 
  13, 12, 16, 12, 13, 12, 16, 12, 12, 11, 15, 11, 12, 11, 15, 11, 16, 15, 21, 15, 16, 15, 21, 15, 12, 11, 15, 11, 12, 11, 15, 11, 13, 12, 16, 12, 13, 12, 16, 12, 12, 11, 15, 11, 12, 11, 15, 11, 16, 15, 21, 15, 16, 15, 21, 15, 12, 11, 15, 11, 12, 11, 15, 11, 
  13, 13, 17, 13, 13, 13, 17, 13, 13, 12, 16, 12, 13, 12, 16, 12, 17, 16, 22, 16, 17, 16, 22, 16, 13, 12, 16, 12, 13, 12, 16, 12, 13, 13, 17, 13, 13, 13, 17, 13, 13, 12, 16, 12, 13, 12, 16, 12, 17, 16, 22, 16, 17, 16, 22, 16, 13, 12, 16, 12, 13, 12, 16, 12, 
  14, 13, 18, 13, 14, 13, 18, 13, 13, 12, 17, 12, 13, 12, 17, 12, 18, 17, 22, 17, 18, 17, 22, 17, 13, 12, 17, 12, 13, 12, 17, 12, 14, 13, 18, 13, 14, 13, 18, 13, 13, 12, 17, 12, 13, 12, 17, 12, 18, 17, 22, 17, 18, 17, 22, 17, 13, 12, 17, 12, 13, 12, 17, 12, 
  15, 14, 19, 14, 15, 14, 19, 14, 14, 13, 17, 13, 14, 13, 17, 13, 19, 17, 23, 17, 19, 17, 23, 17, 14, 13, 17, 13, 14, 13, 17, 13, 15, 14, 19, 14, 15, 14, 19, 14, 14, 13, 17, 13, 14, 13, 17, 13, 19, 17, 23, 17, 19, 17, 23, 17, 14, 13, 17, 13, 14, 13, 17, 13, 
  15, 14, 19, 14, 15, 14, 19, 14, 14, 14, 18, 14, 14, 14, 18, 14, 19, 18, 25, 18, 19, 18, 25, 18, 14, 14, 18, 14, 14, 14, 18, 14, 15, 14, 19, 14, 15, 14, 19, 14, 14, 14, 18, 14, 14, 14, 18, 14, 19, 18, 25, 18, 19, 18, 25, 18, 14, 14, 18, 14, 14, 14, 18, 14, 
  16, 15, 20, 15, 16, 15, 20, 15, 15, 14, 19, 14, 15, 14, 19, 14, 20, 19, 26, 19, 20, 19, 26, 19, 15, 14, 19, 14, 15, 14, 19, 14, 16, 15, 20, 15, 16, 15, 20, 15, 15, 14, 19, 14, 15, 14, 19, 14, 20, 19, 26, 19, 20, 19, 26, 19, 15, 14, 19, 14, 15, 14, 19, 14, 
  17, 16, 21, 16, 17, 16, 21, 16, 16, 15, 20, 15, 16, 15, 20, 15, 21, 20, 27, 20, 21, 20, 27, 20, 16, 15, 20, 15, 16, 15, 20, 15, 17, 16, 21, 16, 17, 16, 21, 16, 16, 15, 20, 15, 16, 15, 20, 15, 21, 20, 27, 20, 21, 20, 27, 20, 16, 15, 20, 15, 16, 15, 20, 15, 
  17, 16, 22, 16, 17, 16, 22, 16, 16, 15, 21, 15, 16, 15, 21, 15, 22, 21, 28, 21, 22, 21, 28, 21, 16, 15, 21, 15, 16, 15, 21, 15, 17, 16, 22, 16, 17, 16, 22, 16, 16, 15, 21, 15, 16, 15, 21, 15, 22, 21, 28, 21, 22, 21, 28, 21, 16, 15, 21, 15, 16, 15, 21, 15, 
  18, 17, 23, 17, 18, 17, 23, 17, 17, 16, 22, 16, 17, 16, 22, 16, 23, 22, 29, 22, 23, 22, 29, 22, 17, 16, 22, 16, 17, 16, 22, 16, 18, 17, 23, 17, 18, 17, 23, 17, 17, 16, 22, 16, 17, 16, 22, 16, 23, 22, 29, 22, 23, 22, 29, 22, 17, 16, 22, 16, 17, 16, 22, 16, 
  19, 18, 24, 18, 19, 18, 24, 18, 18, 17, 23, 17, 18, 17, 23, 17, 24, 23, 30, 23, 24, 23, 30, 23, 18, 17, 23, 17, 18, 17, 23, 17, 19, 18, 24, 18, 19, 18, 24, 18, 18, 17, 23, 17, 18, 17, 23, 17, 24, 23, 30, 23, 24, 23, 30, 23, 18, 17, 23, 17, 18, 17, 23, 17, 
  20, 19, 25, 19, 20, 19, 25, 19, 19, 18, 24, 18, 19, 18, 24, 18, 25, 24, 32, 24, 25, 24, 32, 24, 19, 18, 24, 18, 19, 18, 24, 18, 20, 19, 25, 19, 20, 19, 25, 19, 19, 18, 24, 18, 19, 18, 24, 18, 25, 24, 32, 24, 25, 24, 32, 24, 19, 18, 24, 18, 19, 18, 24, 18, 
  21, 20, 26, 20, 21, 20, 26, 20, 20, 18, 25, 18, 20, 18, 25, 18, 26, 25, 33, 25, 26, 25, 33, 25, 20, 18, 25, 18, 20, 18, 25, 18, 21, 20, 26, 20, 21, 20, 26, 20, 20, 18, 25, 18, 20, 18, 25, 18, 26, 25, 33, 25, 26, 25, 33, 25, 20, 18, 25, 18, 20, 18, 25, 18, 
  22, 20, 27, 20, 22, 20, 27, 20, 20, 19, 26, 19, 20, 19, 26, 19, 27, 26, 35, 26, 27, 26, 35, 26, 20, 19, 26, 19, 20, 19, 26, 19, 22, 20, 27, 20, 22, 20, 27, 20, 20, 19, 26, 19, 20, 19, 26, 19, 27, 26, 35, 26, 27, 26, 35, 26, 20, 19, 26, 19, 20, 19, 26, 19, 
  23, 21, 29, 21, 23, 21, 29, 21, 21, 20, 27, 20, 21, 20, 27, 20, 29, 27, 36, 27, 29, 27, 36, 27, 21, 20, 27, 20, 21, 20, 27, 20, 23, 21, 29, 21, 23, 21, 29, 21, 21, 20, 27, 20, 21, 20, 27, 20, 29, 27, 36, 27, 29, 27, 36, 27, 21, 20, 27, 20, 21, 20, 27, 20, 
  24, 22, 30, 22, 24, 22, 30, 22, 22, 21, 28, 21, 22, 21, 28, 21, 30, 28, 38, 28, 30, 28, 38, 28, 22, 21, 28, 21, 22, 21, 28, 21, 24, 22, 30, 22, 24, 22, 30, 22, 22, 21, 28, 21, 22, 21, 28, 21, 30, 28, 38, 28, 30, 28, 38, 28, 22, 21, 28, 21, 22, 21, 28, 21, 
  25, 23, 31, 23, 25, 23, 31, 23, 23, 22, 29, 22, 23, 22, 29, 22, 31, 29, 39, 29, 31, 29, 39, 29, 23, 22, 29, 22, 23, 22, 29, 22, 25, 23, 31, 23, 25, 23, 31, 23, 23, 22, 29, 22, 23, 22, 29, 22, 31, 29, 39, 29, 31, 29, 39, 29, 23, 22, 29, 22, 23, 22, 29, 22, 
  26, 24, 33, 24, 26, 24, 33, 24, 24, 23, 31, 23, 24, 23, 31, 23, 33, 31, 41, 31, 33, 31, 41, 31, 24, 23, 31, 23, 24, 23, 31, 23, 26, 24, 33, 24, 26, 24, 33, 24, 24, 23, 31, 23, 24, 23, 31, 23, 33, 31, 41, 31, 33, 31, 41, 31, 24, 23, 31, 23, 24, 23, 31, 23, 
  27, 25, 34, 25, 27, 25, 34, 25, 25, 24, 32, 24, 25, 24, 32, 24, 34, 32, 43, 32, 34, 32, 43, 32, 25, 24, 32, 24, 25, 24, 32, 24, 27, 25, 34, 25, 27, 25, 34, 25, 25, 24, 32, 24, 25, 24, 32, 24, 34, 32, 43, 32, 34, 32, 43, 32, 25, 24, 32, 24, 25, 24, 32, 24, 
  28, 26, 36, 26, 28, 26, 36, 26, 26, 25, 33, 25, 26, 25, 33, 25, 36, 33, 45, 33, 36, 33, 45, 33, 26, 25, 33, 25, 26, 25, 33, 25, 28, 26, 36, 26, 28, 26, 36, 26, 26, 25, 33, 25, 26, 25, 33, 25, 36, 33, 45, 33, 36, 33, 45, 33, 26, 25, 33, 25, 26, 25, 33, 25, 
  29, 28, 37, 28, 29, 28, 37, 28, 28, 26, 35, 26, 28, 26, 35, 26, 37, 35, 47, 35, 37, 35, 47, 35, 28, 26, 35, 26, 28, 26, 35, 26, 29, 28, 37, 28, 29, 28, 37, 28, 28, 26, 35, 26, 28, 26, 35, 26, 37, 35, 47, 35, 37, 35, 47, 35, 28, 26, 35, 26, 28, 26, 35, 26, 
  31, 29, 39, 29, 31, 29, 39, 29, 29, 27, 36, 27, 29, 27, 36, 27, 39, 36, 49, 36, 39, 36, 49, 36, 29, 27, 36, 27, 29, 27, 36, 27, 31, 29, 39, 29, 31, 29, 39, 29, 29, 27, 36, 27, 29, 27, 36, 27, 39, 36, 49, 36, 39, 36, 49, 36, 29, 27, 36, 27, 29, 27, 36, 27, 
  32, 30, 40, 30, 32, 30, 40, 30, 30, 28, 38, 28, 30, 28, 38, 28, 40, 38, 51, 38, 40, 38, 51, 38, 30, 28, 38, 28, 30, 28, 38, 28, 32, 30, 40, 30, 32, 30, 40, 30, 30, 28, 38, 28, 30, 28, 38, 28, 40, 38, 51, 38, 40, 38, 51, 38, 30, 28, 38, 28, 30, 28, 38, 28, 
  33, 31, 42, 31, 33, 31, 42, 31, 31, 30, 40, 30, 31, 30, 40, 30, 42, 40, 53, 40, 42, 40, 53, 40, 31, 30, 40, 30, 31, 30, 40, 30, 33, 31, 42, 31, 33, 31, 42, 31, 31, 30, 40, 30, 31, 30, 40, 30, 42, 40, 53, 40, 42, 40, 53, 40, 31, 30, 40, 30, 31, 30, 40, 30, 
  35, 33, 44, 33, 35, 33, 44, 33, 33, 31, 42, 31, 33, 31, 42, 31, 44, 42, 56, 42, 44, 42, 56, 42, 33, 31, 42, 31, 33, 31, 42, 31, 35, 33, 44, 33, 35, 33, 44, 33, 33, 31, 42, 31, 33, 31, 42, 31, 44, 42, 56, 42, 44, 42, 56, 42, 33, 31, 42, 31, 33, 31, 42, 31, 
  36, 34, 46, 34, 36, 34, 46, 34, 34, 32, 43, 32, 34, 32, 43, 32, 46, 43, 58, 43, 46, 43, 58, 43, 34, 32, 43, 32, 34, 32, 43, 32, 36, 34, 46, 34, 36, 34, 46, 34, 34, 32, 43, 32, 34, 32, 43, 32, 46, 43, 58, 43, 46, 43, 58, 43, 34, 32, 43, 32, 34, 32, 43, 32, 
  38, 36, 48, 36, 38, 36, 48, 36, 36, 34, 45, 34, 36, 34, 45, 34, 48, 45, 61, 45, 48, 45, 61, 45, 36, 34, 45, 34, 36, 34, 45, 34, 38, 36, 48, 36, 38, 36, 48, 36, 36, 34, 45, 34, 36, 34, 45, 34, 48, 45, 61, 45, 48, 45, 61, 45, 36, 34, 45, 34, 36, 34, 45, 34, 
  40, 37, 50, 37, 40, 37, 50, 37, 37, 35, 47, 35, 37, 35, 47, 35, 50, 47, 64, 47, 50, 47, 64, 47, 37, 35, 47, 35, 37, 35, 47, 35, 40, 37, 50, 37, 40, 37, 50, 37, 37, 35, 47, 35, 37, 35, 47, 35, 50, 47, 64, 47, 50, 47, 64, 47, 37, 35, 47, 35, 37, 35, 47, 35, 
  41, 39, 52, 39, 41, 39, 52, 39, 39, 37, 49, 37, 39, 37, 49, 37, 52, 49, 66, 49, 52, 49, 66, 49, 39, 37, 49, 37, 39, 37, 49, 37, 41, 39, 52, 39, 41, 39, 52, 39, 39, 37, 49, 37, 39, 37, 49, 37, 52, 49, 66, 49, 52, 49, 66, 49, 39, 37, 49, 37, 39, 37, 49, 37, 
  43, 41, 55, 41, 43, 41, 55, 41, 41, 38, 52, 38, 41, 38, 52, 38, 55, 52, 69, 52, 55, 52, 69, 52, 41, 38, 52, 38, 41, 38, 52, 38, 43, 41, 55, 41, 43, 41, 55, 41, 41, 38, 52, 38, 41, 38, 52, 38, 55, 52, 69, 52, 55, 52, 69, 52, 41, 38, 52, 38, 41, 38, 52, 38, 
  45, 43, 57, 43, 45, 43, 57, 43, 43, 40, 54, 40, 43, 40, 54, 40, 57, 54, 72, 54, 57, 54, 72, 54, 43, 40, 54, 40, 43, 40, 54, 40, 45, 43, 57, 43, 45, 43, 57, 43, 43, 40, 54, 40, 43, 40, 54, 40, 57, 54, 72, 54, 57, 54, 72, 54, 43, 40, 54, 40, 43, 40, 54, 40, 
  47, 44, 60, 44, 47, 44, 60, 44, 44, 42, 56, 42, 44, 42, 56, 42, 60, 56, 76, 56, 60, 56, 76, 56, 44, 42, 56, 42, 44, 42, 56, 42, 47, 44, 60, 44, 47, 44, 60, 44, 44, 42, 56, 42, 44, 42, 56, 42, 60, 56, 76, 56, 60, 56, 76, 56, 44, 42, 56, 42, 44, 42, 56, 42, 
  49, 46, 62, 46, 49, 46, 62, 46, 46, 44, 59, 44, 46, 44, 59, 44, 62, 59, 79, 59, 62, 59, 79, 59, 46, 44, 59, 44, 46, 44, 59, 44, 49, 46, 62, 46, 49, 46, 62, 46, 46, 44, 59, 44, 46, 44, 59, 44, 62, 59, 79, 59, 62, 59, 79, 59, 46, 44, 59, 44, 46, 44, 59, 44, 
  52, 49, 65, 49, 52, 49, 65, 49, 49, 46, 61, 46, 49, 46, 61, 46, 65, 61, 82, 61, 65, 61, 82, 61, 49, 46, 61, 46, 49, 46, 61, 46, 52, 49, 65, 49, 52, 49, 65, 49, 49, 46, 61, 46, 49, 46, 61, 46, 65, 61, 82, 61, 65, 61, 82, 61, 49, 46, 61, 46, 49, 46, 61, 46, 
  54, 51, 68, 51, 54, 51, 68, 51, 51, 48, 64, 48, 51, 48, 64, 48, 68, 64, 86, 64, 68, 64, 86, 64, 51, 48, 64, 48, 51, 48, 64, 48, 54, 51, 68, 51, 54, 51, 68, 51, 51, 48, 64, 48, 51, 48, 64, 48, 68, 64, 86, 64, 68, 64, 86, 64, 51, 48, 64, 48, 51, 48, 64, 48, 
  56, 53, 71, 53, 56, 53, 71, 53, 53, 50, 67, 50, 53, 50, 67, 50, 71, 67, 90, 67, 71, 67, 90, 67, 53, 50, 67, 50, 53, 50, 67, 50, 56, 53, 71, 53, 56, 53, 71, 53, 53, 50, 67, 50, 53, 50, 67, 50, 71, 67, 90, 67, 71, 67, 90, 67, 53, 50, 67, 50, 53, 50, 67, 50, 
  59, 55, 74, 55, 59, 55, 74, 55, 55, 52, 70, 52, 55, 52, 70, 52, 74, 70, 94, 70, 74, 70, 94, 70, 55, 52, 70, 52, 55, 52, 70, 52, 59, 55, 74, 55, 59, 55, 74, 55, 55, 52, 70, 52, 55, 52, 70, 52, 74, 70, 94, 70, 74, 70, 94, 70, 55, 52, 70, 52, 55, 52, 70, 52, 
  61, 58, 78, 58, 61, 58, 78, 58, 58, 54, 73, 54, 58, 54, 73, 54, 78, 73, 98, 73, 78, 73, 98, 73, 58, 54, 73, 54, 58, 54, 73, 54, 61, 58, 78, 58, 61, 58, 78, 58, 58, 54, 73, 54, 58, 54, 73, 54, 78, 73, 98, 73, 78, 73, 98, 73, 58, 54, 73, 54, 58, 54, 73, 54, 
  64, 60, 81, 60, 64, 60, 81, 60, 60, 57, 76, 57, 60, 57, 76, 57, 81, 76, 102, 76, 81, 76, 102, 76, 60, 57, 76, 57, 60, 57, 76, 57, 64, 60, 81, 60, 64, 60, 81, 60, 60, 57, 76, 57, 60, 57, 76, 57, 81, 76, 102, 76, 81, 76, 102, 76, 60, 57, 76, 57, 60, 57, 76, 57, 
  67, 63, 85, 63, 67, 63, 85, 63, 63, 59, 80, 59, 63, 59, 80, 59, 85, 80, 107, 80, 85, 80, 107, 80, 63, 59, 80, 59, 63, 59, 80, 59, 67, 63, 85, 63, 67, 63, 85, 63, 63, 59, 80, 59, 63, 59, 80, 59, 85, 80, 107, 80, 85, 80, 107, 80, 63, 59, 80, 59, 63, 59, 80, 59, 
  70, 66, 88, 66, 70, 66, 88, 66, 66, 62, 83, 62, 66, 62, 83, 62, 88, 83, 112, 83, 88, 83, 112, 83, 66, 62, 83, 62, 66, 62, 83, 62, 70, 66, 88, 66, 70, 66, 88, 66, 66, 62, 83, 62, 66, 62, 83, 62, 88, 83, 112, 83, 88, 83, 112, 83, 66, 62, 83, 62, 66, 62, 83, 62, 
  73, 69, 92, 69, 73, 69, 92, 69, 69, 65, 87, 65, 69, 65, 87, 65, 92, 87, 117, 87, 92, 87, 117, 87, 69, 65, 87, 65, 69, 65, 87, 65, 73, 69, 92, 69, 73, 69, 92, 69, 69, 65, 87, 65, 69, 65, 87, 65, 92, 87, 117, 87, 92, 87, 117, 87, 69, 65, 87, 65, 69, 65, 87, 65, 
  76, 72, 96, 72, 76, 72, 96, 72, 72, 67, 91, 67, 72, 67, 91, 67, 96, 91, 122, 91, 96, 91, 122, 91, 72, 67, 91, 67, 72, 67, 91, 67, 76, 72, 96, 72, 76, 72, 96, 72, 72, 67, 91, 67, 72, 67, 91, 67, 96, 91, 122, 91, 96, 91, 122, 91, 72, 67, 91, 67, 72, 67, 91, 67, 
  79, 75, 101, 75, 79, 75, 101, 75, 75, 70, 95, 70, 75, 70, 95, 70, 101, 95, 127, 95, 101, 95, 127, 95, 75, 70, 95, 70, 75, 70, 95, 70, 79, 75, 101, 75, 79, 75, 101, 75, 75, 70, 95, 70, 75, 70, 95, 70, 101, 95, 127, 95, 101, 95, 127, 95, 75, 70, 95, 70, 75, 70, 95, 70, 
  83, 78, 105, 78, 83, 78, 105, 78, 78, 74, 99, 74, 78, 74, 99, 74, 105, 99, 133, 99, 105, 99, 133, 99, 78, 74, 99, 74, 78, 74, 99, 74, 83, 78, 105, 78, 83, 78, 105, 78, 78, 74, 99, 74, 78, 74, 99, 74, 105, 99, 133, 99, 105, 99, 133, 99, 78, 74, 99, 74, 78, 74, 99, 74, 
  87, 82, 110, 82, 87, 82, 110, 82, 82, 77, 103, 77, 82, 77, 103, 77, 110, 103, 139, 103, 110, 103, 139, 103, 82, 77, 103, 77, 82, 77, 103, 77, 87, 82, 110, 82, 87, 82, 110, 82, 82, 77, 103, 77, 82, 77, 103, 77, 110, 103, 139, 103, 110, 103, 139, 103, 82, 77, 103, 77, 82, 77, 103, 77, 
  91, 85, 114, 85, 91, 85, 114, 85, 85, 80, 108, 80, 85, 80, 108, 80, 114, 108, 145, 108, 114, 108, 145, 108, 85, 80, 108, 80, 85, 80, 108, 80, 91, 85, 114, 85, 91, 85, 114, 85, 85, 80, 108, 80, 85, 80, 108, 80, 114, 108, 145, 108, 114, 108, 145, 108, 85, 80, 108, 80, 85, 80, 108, 80, 
  95, 89, 120, 89, 95, 89, 120, 89, 89, 84, 113, 84, 89, 84, 113, 84, 120, 113, 151, 113, 120, 113, 151, 113, 89, 84, 113, 84, 89, 84, 113, 84, 95, 89, 120, 89, 95, 89, 120, 89, 89, 84, 113, 84, 89, 84, 113, 84, 120, 113, 151, 113, 120, 113, 151, 113, 89, 84, 113, 84, 89, 84, 113, 84, 
  99, 93, 125, 93, 99, 93, 125, 93, 93, 87, 118, 87, 93, 87, 118, 87, 125, 118, 158, 118, 125, 118, 158, 118, 93, 87, 118, 87, 93, 87, 118, 87, 99, 93, 125, 93, 99, 93, 125, 93, 93, 87, 118, 87, 93, 87, 118, 87, 125, 118, 158, 118, 125, 118, 158, 118, 93, 87, 118, 87, 93, 87, 118, 87, 
  103, 97, 130, 97, 103, 97, 130, 97, 97, 91, 123, 91, 97, 91, 123, 91, 130, 123, 165, 123, 130, 123, 165, 123, 97, 91, 123, 91, 97, 91, 123, 91, 103, 97, 130, 97, 103, 97, 130, 97, 97, 91, 123, 91, 97, 91, 123, 91, 130, 123, 165, 123, 130, 123, 165, 123, 97, 91, 123, 91, 97, 91, 123, 91, 
  108, 101, 136, 101, 108, 101, 136, 101, 101, 95, 128, 95, 101, 95, 128, 95, 136, 128, 172, 128, 136, 128, 172, 128, 101, 95, 128, 95, 101, 95, 128, 95, 108, 101, 136, 101, 108, 101, 136, 101, 101, 95, 128, 95, 101, 95, 128, 95, 136, 128, 172, 128, 136, 128, 172, 128, 101, 95, 128, 95, 101, 95, 128, 95, 
  112, 106, 142, 106, 112, 106, 142, 106, 106, 100, 134, 100, 106, 100, 134, 100, 142, 134, 180, 134, 142, 134, 180, 134, 106, 100, 134, 100, 106, 100, 134, 100, 112, 106, 142, 106, 112, 106, 142, 106, 106, 100, 134, 100, 106, 100, 134, 100, 142, 134, 180, 134, 142, 134, 180, 134, 106, 100, 134, 100, 106, 100, 134, 100, 
  117, 110, 148, 110, 117, 110, 148, 110, 110, 104, 140, 104, 110, 104, 140, 104, 148, 140, 188, 140, 148, 140, 188, 140, 110, 104, 140, 104, 110, 104, 140, 104, 117, 110, 148, 110, 117, 110, 148, 110, 110, 104, 140, 104, 110, 104, 140, 104, 148, 140, 188, 140, 148, 140, 188, 140, 110, 104, 140, 104, 110, 104, 140, 104, 
  123, 115, 155, 115, 123, 115, 155, 115, 115, 109, 146, 109, 115, 109, 146, 109, 155, 146, 196, 146, 155, 146, 196, 146, 115, 109, 146, 109, 115, 109, 146, 109, 123, 115, 155, 115, 123, 115, 155, 115, 115, 109, 146, 109, 115, 109, 146, 109, 155, 146, 196, 146, 155, 146, 196, 146, 115, 109, 146, 109, 115, 109, 146, 109, 
  128, 120, 162, 120, 128, 120, 162, 120, 120, 113, 152, 113, 120, 113, 152, 113, 162, 152, 205, 152, 162, 152, 205, 152, 120, 113, 152, 113, 120, 113, 152, 113, 128, 120, 162, 120, 128, 120, 162, 120, 120, 113, 152, 113, 120, 113, 152, 113, 162, 152, 205, 152, 162, 152, 205, 152, 120, 113, 152, 113, 120, 113, 152, 113, 
  134, 126, 169, 126, 134, 126, 169, 126, 126, 118, 159, 118, 126, 118, 159, 118, 169, 159, 214, 159, 169, 159, 214, 159, 126, 118, 159, 118, 126, 118, 159, 118, 134, 126, 169, 126, 134, 126, 169, 126, 126, 118, 159, 118, 126, 118, 159, 118, 169, 159, 214, 159, 169, 159, 214, 159, 126, 118, 159, 118, 126, 118, 159, 118, 
  140, 131, 177, 131, 140, 131, 177, 131, 131, 124, 166, 124, 131, 124, 166, 124, 177, 166, 223, 166, 177, 166, 223, 166, 131, 124, 166, 124, 131, 124, 166, 124, 140, 131, 177, 131, 140, 131, 177, 131, 131, 124, 166, 124, 131, 124, 166, 124, 177, 166, 223, 166, 177, 166, 223, 166, 131, 124, 166, 124, 131, 124, 166, 124, 
  146, 137, 184, 137, 146, 137, 184, 137, 137, 129, 174, 129, 137, 129, 174, 129, 184, 174, 233, 174, 184, 174, 233, 174, 137, 129, 174, 129, 137, 129, 174, 129, 146, 137, 184, 137, 146, 137, 184, 137, 137, 129, 174, 129, 137, 129, 174, 129, 184, 174, 233, 174, 184, 174, 233, 174, 137, 129, 174, 129, 137, 129, 174, 129, 
  152, 143, 193, 143, 152, 143, 193, 143, 143, 135, 181, 135, 143, 135, 181, 135, 193, 181, 244, 181, 193, 181, 244, 181, 143, 135, 181, 135, 143, 135, 181, 135, 152, 143, 193, 143, 152, 143, 193, 143, 143, 135, 181, 135, 143, 135, 181, 135, 193, 181, 244, 181, 193, 181, 244, 181, 143, 135, 181, 135, 143, 135, 181, 135, 
  159, 150, 201, 150, 159, 150, 201, 150, 150, 141, 189, 141, 150, 141, 189, 141, 201, 189, 254, 189, 201, 189, 254, 189, 150, 141, 189, 141, 150, 141, 189, 141, 159, 150, 201, 150, 159, 150, 201, 150, 150, 141, 189, 141, 150, 141, 189, 141, 201, 189, 254, 189, 201, 189, 254, 189, 150, 141, 189, 141, 150, 141, 189, 141, 
  166, 156, 210, 156, 166, 156, 210, 156, 156, 147, 198, 147, 156, 147, 198, 147, 210, 198, 266, 198, 210, 198, 266, 198, 156, 147, 198, 147, 156, 147, 198, 147, 166, 156, 210, 156, 166, 156, 210, 156, 156, 147, 198, 147, 156, 147, 198, 147, 210, 198, 266, 198, 210, 198, 266, 198, 156, 147, 198, 147, 156, 147, 198, 147, 
  173, 163, 219, 163, 173, 163, 219, 163, 163, 154, 206, 154, 163, 154, 206, 154, 219, 206, 277, 206, 219, 206, 277, 206, 163, 154, 206, 154, 163, 154, 206, 154, 173, 163, 219, 163, 173, 163, 219, 163, 163, 154, 206, 154, 163, 154, 206, 154, 219, 206, 277, 206, 219, 206, 277, 206, 163, 154, 206, 154, 163, 154, 206, 154, 
  181, 170, 229, 170, 181, 170, 229, 170, 170, 160, 216, 160, 170, 160, 216, 160, 229, 216, 290, 216, 229, 216, 290, 216, 170, 160, 216, 160, 170, 160, 216, 160, 181, 170, 229, 170, 181, 170, 229, 170, 170, 160, 216, 160, 170, 160, 216, 160, 229, 216, 290, 216, 229, 216, 290, 216, 170, 160, 216, 160, 170, 160, 216, 160, 
  189, 178, 239, 178, 189, 178, 239, 178, 178, 167, 225, 167, 178, 167, 225, 167, 239, 225, 302, 225, 239, 225, 302, 225, 178, 167, 225, 167, 178, 167, 225, 167, 189, 178, 239, 178, 189, 178, 239, 178, 178, 167, 225, 167, 178, 167, 225, 167, 239, 225, 302, 225, 239, 225, 302, 225, 178, 167, 225, 167, 178, 167, 225, 167, 
  197, 186, 250, 186, 197, 186, 250, 186, 186, 175, 235, 175, 186, 175, 235, 175, 250, 235, 316, 235, 250, 235, 316, 235, 186, 175, 235, 175, 186, 175, 235, 175, 197, 186, 250, 186, 197, 186, 250, 186, 186, 175, 235, 175, 186, 175, 235, 175, 250, 235, 316, 235, 250, 235, 316, 235, 186, 175, 235, 175, 186, 175, 235, 175, 
  206, 194, 261, 194, 206, 194, 261, 194, 194, 183, 245, 183, 194, 183, 245, 183, 261, 245, 330, 245, 261, 245, 330, 245, 194, 183, 245, 183, 194, 183, 245, 183, 206, 194, 261, 194, 206, 194, 261, 194, 194, 183, 245, 183, 194, 183, 245, 183, 261, 245, 330, 245, 261, 245, 330, 245, 194, 183, 245, 183, 194, 183, 245, 183, 
  215, 203, 272, 203, 215, 203, 272, 203, 203, 191, 256, 191, 203, 191, 256, 191, 272, 256, 344, 256, 272, 256, 344, 256, 203, 191, 256, 191, 203, 191, 256, 191, 215, 203, 272, 203, 215, 203, 272, 203, 203, 191, 256, 191, 203, 191, 256, 191, 272, 256, 344, 256, 272, 256, 344, 256, 203, 191, 256, 191, 203, 191, 256, 191, 
  225, 212, 284, 212, 225, 212, 284, 212, 212, 199, 268, 199, 212, 199, 268, 199, 284, 268, 360, 268, 284, 268, 360, 268, 212, 199, 268, 199, 212, 199, 268, 199, 225, 212, 284, 212, 225, 212, 284, 212, 212, 199, 268, 199, 212, 199, 268, 199, 284, 268, 360, 268, 284, 268, 360, 268, 212, 199, 268, 199, 212, 199, 268, 199, 
  235, 221, 297, 221, 235, 221, 297, 221, 221, 208, 279, 208, 221, 208, 279, 208, 297, 279, 376, 279, 297, 279, 376, 279, 221, 208, 279, 208, 221, 208, 279, 208, 235, 221, 297, 221, 235, 221, 297, 221, 221, 208, 279, 208, 221, 208, 279, 208, 297, 279, 376, 279, 297, 279, 376, 279, 221, 208, 279, 208, 221, 208, 279, 208, 
  245, 231, 310, 231, 245, 231, 310, 231, 231, 217, 292, 217, 231, 217, 292, 217, 310, 292, 392, 292, 310, 292, 392, 292, 231, 217, 292, 217, 231, 217, 292, 217, 245, 231, 310, 231, 245, 231, 310, 231, 231, 217, 292, 217, 231, 217, 292, 217, 310, 292, 392, 292, 310, 292, 392, 292, 231, 217, 292, 217, 231, 217, 292, 217, 
  256, 241, 324, 241, 256, 241, 324, 241, 241, 227, 305, 227, 241, 227, 305, 227, 324, 305, 410, 305, 324, 305, 410, 305, 241, 227, 305, 227, 241, 227, 305, 227, 256, 241, 324, 241, 256, 241, 324, 241, 241, 227, 305, 227, 241, 227, 305, 227, 324, 305, 410, 305, 324, 305, 410, 305, 241, 227, 305, 227, 241, 227, 305, 227, 
  267, 252, 338, 252, 267, 252, 338, 252, 252, 237, 318, 237, 252, 237, 318, 237, 338, 318, 428, 318, 338, 318, 428, 318, 252, 237, 318, 237, 252, 237, 318, 237, 267, 252, 338, 252, 267, 252, 338, 252, 252, 237, 318, 237, 252, 237, 318, 237, 338, 318, 428, 318, 338, 318, 428, 318, 252, 237, 318, 237, 252, 237, 318, 237, 
  279, 263, 353, 263, 279, 263, 353, 263, 263, 247, 332, 247, 263, 247, 332, 247, 353, 332, 447, 332, 353, 332, 447, 332, 263, 247, 332, 247, 263, 247, 332, 247, 279, 263, 353, 263, 279, 263, 353, 263, 263, 247, 332, 247, 263, 247, 332, 247, 353, 332, 447, 332, 353, 332, 447, 332, 263, 247, 332, 247, 263, 247, 332, 247, 
  293, 274, 369, 274, 293, 274, 369, 274, 274, 258, 347, 258, 274, 258, 347, 258, 369, 347, 466, 347, 369, 347, 466, 347, 274, 258, 347, 258, 274, 258, 347, 258, 293, 274, 369, 274, 293, 274, 369, 274, 274, 258, 347, 258, 274, 258, 347, 258, 369, 347, 466, 347, 369, 347, 466, 347, 274, 258, 347, 258, 274, 258, 347, 258, 
  303, 287, 386, 287, 303, 287, 386, 287, 287, 271, 361, 271, 287, 271, 361, 271, 386, 361, 486, 361, 386, 361, 486, 361, 287, 271, 361, 271, 287, 271, 361, 271, 303, 287, 386, 287, 303, 287, 386, 287, 287, 271, 361, 271, 287, 271, 361, 271, 386, 361, 486, 361, 386, 361, 486, 361, 287, 271, 361, 271, 287, 271, 361, 271, 
  318, 299, 402, 299, 318, 299, 402, 299, 299, 283, 378, 283, 299, 283, 378, 283, 402, 378, 508, 378, 402, 378, 508, 378, 299, 283, 378, 283, 299, 283, 378, 283, 318, 299, 402, 299, 318, 299, 402, 299, 299, 283, 378, 283, 299, 283, 378, 283, 402, 378, 508, 378, 402, 378, 508, 378, 299, 283, 378, 283, 299, 283, 378, 283, 
  333, 312, 419, 312, 333, 312, 419, 312, 312, 294, 395, 294, 312, 294, 395, 294, 419, 395, 531, 395, 419, 395, 531, 395, 312, 294, 395, 294, 312, 294, 395, 294, 333, 312, 419, 312, 333, 312, 419, 312, 312, 294, 395, 294, 312, 294, 395, 294, 419, 395, 531, 395, 419, 395, 531, 395, 312, 294, 395, 294, 312, 294, 395, 294, 
  347, 326, 439, 326, 347, 326, 439, 326, 326, 306, 413, 306, 326, 306, 413, 306, 439, 413, 556, 413, 439, 413, 556, 413, 326, 306, 413, 306, 326, 306, 413, 306, 347, 326, 439, 326, 347, 326, 439, 326, 326, 306, 413, 306, 326, 306, 413, 306, 439, 413, 556, 413, 439, 413, 556, 413, 326, 306, 413, 306, 326, 306, 413, 306, 
  362, 341, 458, 341, 362, 341, 458, 341, 341, 321, 430, 321, 341, 321, 430, 321, 458, 430, 579, 430, 458, 430, 579, 430, 341, 321, 430, 321, 341, 321, 430, 321, 362, 341, 458, 341, 362, 341, 458, 341, 341, 321, 430, 321, 341, 321, 430, 321, 458, 430, 579, 430, 458, 430, 579, 430, 341, 321, 430, 321, 341, 321, 430, 321, 
  379, 356, 479, 356, 379, 356, 479, 356, 356, 334, 451, 334, 356, 334, 451, 334, 479, 451, 606, 451, 479, 451, 606, 451, 356, 334, 451, 334, 356, 334, 451, 334, 379, 356, 479, 356, 379, 356, 479, 356, 356, 334, 451, 334, 356, 334, 451, 334, 479, 451, 606, 451, 479, 451, 606, 451, 356, 334, 451, 334, 356, 334, 451, 334, 
  395, 372, 499, 372, 395, 372, 499, 372, 372, 350, 469, 350, 372, 350, 469, 350, 499, 469, 633, 469, 499, 469, 633, 469, 372, 350, 469, 350, 372, 350, 469, 350, 395, 372, 499, 372, 395, 372, 499, 372, 372, 350, 469, 350, 372, 350, 469, 350, 499, 469, 633, 469, 499, 469, 633, 469, 372, 350, 469, 350, 372, 350, 469, 350, 
  412, 387, 522, 387, 412, 387, 522, 387, 387, 365, 491, 365, 387, 365, 491, 365, 522, 491, 661, 491, 522, 491, 661, 491, 387, 365, 491, 365, 387, 365, 491, 365, 412, 387, 522, 387, 412, 387, 522, 387, 387, 365, 491, 365, 387, 365, 491, 365, 522, 491, 661, 491, 522, 491, 661, 491, 387, 365, 491, 365, 387, 365, 491, 365, 
  431, 406, 546, 406, 431, 406, 546, 406, 406, 381, 513, 381, 406, 381, 513, 381, 546, 513, 688, 513, 546, 513, 688, 513, 406, 381, 513, 381, 406, 381, 513, 381, 431, 406, 546, 406, 431, 406, 546, 406, 406, 381, 513, 381, 406, 381, 513, 381, 546, 513, 688, 513, 546, 513, 688, 513, 406, 381, 513, 381, 406, 381, 513, 381, 
  449, 424, 570, 424, 449, 424, 570, 424, 424, 399, 534, 399, 424, 399, 534, 399, 570, 534, 720, 534, 570, 534, 720, 534, 424, 399, 534, 399, 424, 399, 534, 399, 449, 424, 570, 424, 449, 424, 570, 424, 424, 399, 534, 399, 424, 399, 534, 399, 570, 534, 720, 534, 570, 534, 720, 534, 424, 399, 534, 399, 424, 399, 534, 399, 
  471, 443, 592, 443, 471, 443, 592, 443, 443, 415, 560, 415, 443, 415, 560, 415, 592, 560, 752, 560, 592, 560, 752, 560, 443, 415, 560, 415, 443, 415, 560, 415, 471, 443, 592, 443, 471, 443, 592, 443, 443, 415, 560, 415, 443, 415, 560, 415, 592, 560, 752, 560, 592, 560, 752, 560, 443, 415, 560, 415, 443, 415, 560, 415, 
  489, 461, 620, 461, 489, 461, 620, 461, 461, 436, 584, 436, 461, 436, 584, 436, 620, 584, 784, 584, 620, 584, 784, 584, 461, 436, 584, 436, 461, 436, 584, 436, 489, 461, 620, 461, 489, 461, 620, 461, 461, 436, 584, 436, 461, 436, 584, 436, 620, 584, 784, 584, 620, 584, 784, 584, 461, 436, 584, 436, 461, 436, 584, 436, 
  512, 484, 647, 484, 512, 484, 647, 484, 484, 455, 611, 455, 484, 455, 611, 455, 647, 611, 818, 611, 647, 611, 818, 611, 484, 455, 611, 455, 484, 455, 611, 455, 512, 484, 647, 484, 512, 484, 647, 484, 484, 455, 611, 455, 484, 455, 611, 455, 647, 611, 818, 611, 647, 611, 818, 611, 484, 455, 611, 455, 484, 455, 611, 455, 
  537, 505, 677, 505, 537, 505, 677, 505, 505, 476, 636, 476, 505, 476, 636, 476, 677, 636, 856, 636, 677, 636, 856, 636, 505, 476, 636, 476, 505, 476, 636, 476, 537, 505, 677, 505, 537, 505, 677, 505, 505, 476, 636, 476, 505, 476, 636, 476, 677, 636, 856, 636, 677, 636, 856, 636, 505, 476, 636, 476, 505, 476, 636, 476, 
  560, 523, 704, 523, 560, 523, 704, 523, 523, 494, 663, 494, 523, 494, 663, 494, 704, 663, 892, 663, 704, 663, 892, 663, 523, 494, 663, 494, 523, 494, 663, 494, 560, 523, 704, 523, 560, 523, 704, 523, 523, 494, 663, 494, 523, 494, 663, 494, 704, 663, 892, 663, 704, 663, 892, 663, 523, 494, 663, 494, 523, 494, 663, 494, 
  585, 548, 738, 548, 585, 548, 738, 548, 548, 514, 693, 514, 548, 514, 693, 514, 738, 693, 932, 693, 738, 693, 932, 693, 548, 514, 693, 514, 548, 514, 693, 514, 585, 548, 738, 548, 585, 548, 738, 548, 548, 514, 693, 514, 548, 514, 693, 514, 738, 693, 932, 693, 738, 693, 932, 693, 548, 514, 693, 514, 548, 514, 693, 514, 
  607, 575, 771, 575, 607, 575, 771, 575, 575, 541, 726, 541, 575, 541, 726, 541, 771, 726, 975, 726, 771, 726, 975, 726, 575, 541, 726, 541, 575, 541, 726, 541, 607, 575, 771, 575, 607, 575, 771, 575, 575, 541, 726, 541, 575, 541, 726, 541, 771, 726, 975, 726, 771, 726, 975, 726, 575, 541, 726, 541, 575, 541, 726, 541, 
  636, 598, 807, 598, 636, 598, 807, 598, 598, 565, 755, 565, 598, 565, 755, 565, 807, 755, 1017, 755, 807, 755, 1017, 755, 598, 565, 755, 565, 598, 565, 755, 565, 636, 598, 807, 598, 636, 598, 807, 598, 598, 565, 755, 565, 598, 565, 755, 565, 807, 755, 1017, 755, 807, 755, 1017, 755, 598, 565, 755, 565, 598, 565, 755, 565, 
  662, 624, 839, 624, 662, 624, 839, 624, 624, 591, 787, 591, 624, 591, 787, 591, 839, 787, 1062, 787, 839, 787, 1062, 787, 624, 591, 787, 591, 624, 591, 787, 591, 662, 624, 839, 624, 662, 624, 839, 624, 624, 591, 787, 591, 624, 591, 787, 591, 839, 787, 1062, 787, 839, 787, 1062, 787, 624, 591, 787, 591, 624, 591, 787, 591, 
  690, 652, 874, 652, 690, 652, 874, 652, 652, 612, 822, 612, 652, 612, 822, 612, 874, 822, 1111, 822, 874, 822, 1111, 822, 652, 612, 822, 612, 652, 612, 822, 612, 690, 652, 874, 652, 690, 652, 874, 652, 652, 612, 822, 612, 652, 612, 822, 612, 874, 822, 1111, 822, 874, 822, 1111, 822, 652, 612, 822, 612, 652, 612, 822, 612, 
  720, 683, 920, 683, 720, 683, 920, 683, 683, 643, 860, 643, 683, 643, 860, 643, 920, 860, 1157, 860, 920, 860, 1157, 860, 683, 643, 860, 643, 683, 643, 860, 643, 720, 683, 920, 683, 720, 683, 920, 683, 683, 643, 860, 643, 683, 643, 860, 643, 920, 860, 1157, 860, 920, 860, 1157, 860, 683, 643, 860, 643, 683, 643, 860, 643, 
  753, 708, 953, 708, 753, 708, 953, 708, 708, 668, 902, 668, 708, 668, 902, 668, 953, 902, 1207, 902, 953, 902, 1207, 902, 708, 668, 902, 668, 708, 668, 902, 668, 753, 708, 953, 708, 753, 708, 953, 708, 708, 668, 902, 668, 708, 668, 902, 668, 953, 902, 1207, 902, 953, 902, 1207, 902, 708, 668, 902, 668, 708, 668, 902, 668, 
  790, 744, 999, 744, 790, 744, 999, 744, 744, 695, 938, 695, 744, 695, 938, 695, 999, 938, 1261, 938, 999, 938, 1261, 938, 744, 695, 938, 695, 744, 695, 938, 695, 790, 744, 999, 744, 790, 744, 999, 744, 744, 695, 938, 695, 744, 695, 938, 695, 999, 938, 1261, 938, 999, 938, 1261, 938, 744, 695, 938, 695, 744, 695, 938, 695, 
  830, 774, 1038, 774, 830, 774, 1038, 774, 774, 735, 978, 735, 774, 735, 978, 735, 1038, 978, 1321, 978, 1038, 978, 1321, 978, 774, 735, 978, 735, 774, 735, 978, 735, 830, 774, 1038, 774, 830, 774, 1038, 774, 774, 735, 978, 735, 774, 735, 978, 735, 1038, 978, 1321, 978, 1038, 978, 1321, 978, 774, 735, 978, 735, 774, 735, 978, 735, 
  862, 806, 1092, 806, 862, 806, 1092, 806, 806, 768, 1021, 768, 806, 768, 1021, 768, 1092, 1021, 1375, 1021, 1092, 1021, 1375, 1021, 806, 768, 1021, 768, 806, 768, 1021, 768, 862, 806, 1092, 806, 862, 806, 1092, 806, 806, 768, 1021, 768, 806, 768, 1021, 768, 1092, 1021, 1375, 1021, 1092, 1021, 1375, 1021, 806, 768, 1021, 768, 806, 768, 1021, 768, 
  898, 841, 1140, 841, 898, 841, 1140, 841, 841, 791, 1068, 791, 841, 791, 1068, 791, 1140, 1068, 1434, 1068, 1140, 1068, 1434, 1068, 841, 791, 1068, 791, 841, 791, 1068, 791, 898, 841, 1140, 841, 898, 841, 1140, 841, 841, 791, 1068, 791, 841, 791, 1068, 791, 1140, 1068, 1434, 1068, 1140, 1068, 1434, 1068, 841, 791, 1068, 791, 841, 791, 1068, 791, 
  936, 880, 1192, 880, 936, 880, 1192, 880, 880, 829, 1119, 829, 880, 829, 1119, 829, 1192, 1119, 1498, 1119, 1192, 1119, 1498, 1119, 880, 829, 1119, 829, 880, 829, 1119, 829, 936, 880, 1192, 880, 936, 880, 1192, 880, 880, 829, 1119, 829, 880, 829, 1119, 829, 1192, 1119, 1498, 1119, 1192, 1119, 1498, 1119, 880, 829, 1119, 829, 880, 829, 1119, 829, 
  978, 921, 1234, 921, 978, 921, 1234, 921, 921, 872, 1161, 872, 921, 872, 1161, 872, 1234, 1161, 1568, 1161, 1234, 1161, 1568, 1161, 921, 872, 1161, 872, 921, 872, 1161, 872, 978, 921, 1234, 921, 978, 921, 1234, 921, 921, 872, 1161, 872, 921, 872, 1161, 872, 1234, 1161, 1568, 1161, 1234, 1161, 1568, 1161, 921, 872, 1161, 872, 921, 872, 1161, 872, 
  1024, 968, 1295, 968, 1024, 968, 1295, 968, 968, 902, 1222, 902, 968, 902, 1222, 902, 1295, 1222, 1645, 1222, 1295, 1222, 1645, 1222, 968, 902, 1222, 902, 968, 902, 1222, 902, 1024, 968, 1295, 968, 1024, 968, 1295, 968, 968, 902, 1222, 902, 968, 902, 1222, 902, 1295, 1222, 1645, 1222, 1295, 1222, 1645, 1222, 968, 902, 1222, 902, 968, 902, 1222, 902, 
  1074, 1001, 1344, 1001, 1074, 1001, 1344, 1001, 1001, 952, 1272, 952, 1001, 952, 1272, 952, 1344, 1272, 1712, 1272, 1344, 1272, 1712, 1272, 1001, 952, 1272, 952, 1001, 952, 1272, 952, 1074, 1001, 1344, 1001, 1074, 1001, 1344, 1001, 1001, 952, 1272, 952, 1001, 952, 1272, 952, 1344, 1272, 1712, 1272, 1344, 1272, 1712, 1272, 1001, 952, 1272, 952, 1001, 952, 1272, 952, 
  1111, 1056, 1417, 1056, 1111, 1056, 1417, 1056, 1056, 989, 1327, 989, 1056, 989, 1327, 989, 1417, 1327, 1785, 1327, 1417, 1327, 1785, 1327, 1056, 989, 1327, 989, 1056, 989, 1327, 989, 1111, 1056, 1417, 1056, 1111, 1056, 1417, 1056, 1056, 989, 1327, 989, 1056, 989, 1327, 989, 1417, 1327, 1785, 1327, 1417, 1327, 1785, 1327, 1056, 989, 1327, 989, 1056, 989, 1327, 989, 
  1170, 1095, 1477, 1095, 1170, 1095, 1477, 1095, 1095, 1028, 1386, 1028, 1095, 1028, 1386, 1028, 1477, 1386, 1864, 1386, 1477, 1386, 1864, 1386, 1095, 1028, 1386, 1028, 1095, 1028, 1386, 1028, 1170, 1095, 1477, 1095, 1170, 1095, 1477, 1095, 1095, 1028, 1386, 1028, 1095, 1028, 1386, 1028, 1477, 1386, 1864, 1386, 1477, 1386, 1864, 1386, 1095, 1028, 1386, 1028, 1095, 1028, 1386, 1028, 
  1214, 1138, 1542, 1138, 1214, 1138, 1542, 1138, 1138, 1071, 1451, 1071, 1138, 1071, 1451, 1071, 1542, 1451, 1951, 1451, 1542, 1451, 1951, 1451, 1138, 1071, 1451, 1071, 1138, 1071, 1451, 1071, 1214, 1138, 1542, 1138, 1214, 1138, 1542, 1138, 1138, 1071, 1451, 1071, 1138, 1071, 1451, 1071, 1542, 1451, 1951, 1451, 1542, 1451, 1951, 1451, 1138, 1071, 1451, 1071, 1138, 1071, 1451, 1071, 
  1260, 1209, 1613, 1209, 1260, 1209, 1613, 1209, 1209, 1118, 1523, 1118, 1209, 1118, 1523, 1118, 1613, 1523, 2046, 1523, 1613, 1523, 2046, 1523, 1209, 1118, 1523, 1118, 1209, 1118, 1523, 1118, 1260, 1209, 1613, 1209, 1260, 1209, 1613, 1209, 1209, 1118, 1523, 1118, 1209, 1118, 1523, 1118, 1613, 1523, 2046, 1523, 1613, 1523, 2046, 1523, 1209, 1118, 1523, 1118, 1209, 1118, 1523, 1118, 
  1337, 1262, 1691, 1262, 1337, 1262, 1691, 1262, 1262, 1169, 1574, 1169, 1262, 1169, 1574, 1169, 1691, 1574, 2124, 1574, 1691, 1574, 2124, 1574, 1262, 1169, 1574, 1169, 1262, 1169, 1574, 1169, 1337, 1262, 1691, 1262, 1337, 1262, 1691, 1262, 1262, 1169, 1574, 1169, 1262, 1169, 1574, 1169, 1691, 1574, 2124, 1574, 1691, 1574, 2124, 1574, 1262, 1169, 1574, 1169, 1262, 1169, 1574, 1169, 
  1394, 1319, 1748, 1319, 1394, 1319, 1748, 1319, 1319, 1224, 1659, 1224, 1319, 1224, 1659, 1224, 1748, 1659, 2208, 1659, 1748, 1659, 2208, 1659, 1319, 1224, 1659, 1224, 1319, 1224, 1659, 1224, 1394, 1319, 1748, 1319, 1394, 1319, 1748, 1319, 1319, 1224, 1659, 1224, 1319, 1224, 1659, 1224, 1748, 1659, 2208, 1659, 1748, 1659, 2208, 1659, 1319, 1224, 1659, 1224, 1319, 1224, 1659, 1224, 
  1456, 1350, 1840, 1350, 1456, 1350, 1840, 1350, 1350, 1286, 1720, 1286, 1350, 1286, 1720, 1286, 1840, 1720, 2330, 1720, 1840, 1720, 2330, 1720, 1350, 1286, 1720, 1286, 1350, 1286, 1720, 1286, 1456, 1350, 1840, 1350, 1456, 1350, 1840, 1350, 1350, 1286, 1720, 1286, 1350, 1286, 1720, 1286, 1840, 1720, 2330, 1720, 1840, 1720, 2330, 1720, 1350, 1286, 1720, 1286, 1350, 1286, 1720, 1286, 
  1524, 1416, 1907, 1416, 1524, 1416, 1907, 1416, 1416, 1353, 1786, 1353, 1416, 1353, 1786, 1353, 1907, 1786, 2431, 1786, 1907, 1786, 2431, 1786, 1416, 1353, 1786, 1353, 1416, 1353, 1786, 1353, 1524, 1416, 1907, 1416, 1524, 1416, 1907, 1416, 1416, 1353, 1786, 1353, 1416, 1353, 1786, 1353, 1907, 1786, 2431, 1786, 1907, 1786, 2431, 1786, 1416, 1353, 1786, 1353, 1416, 1353, 1786, 1353, 
  1560, 1489, 2016, 1489, 1560, 1489, 2016, 1489, 1489, 1390, 1896, 1390, 1489, 1390, 1896, 1390, 2016, 1896, 2542, 1896, 2016, 1896, 2542, 1896, 1489, 1390, 1896, 1390, 1489, 1390, 1896, 1390, 1560, 1489, 2016, 1489, 1560, 1489, 2016, 1489, 1489, 1390, 1896, 1390, 1489, 1390, 1896, 1390, 2016, 1896, 2542, 1896, 2016, 1896, 2542, 1896, 1489, 1390, 1896, 1390, 1489, 1390, 1896, 1390, 
  1638, 1569, 2097, 1569, 1638, 1569, 2097, 1569, 1569, 1469, 1976, 1469, 1569, 1469, 1976, 1469, 2097, 1976, 2621, 1976, 2097, 1976, 2621, 1976, 1569, 1469, 1976, 1469, 1569, 1469, 1976, 1469, 1638, 1569, 2097, 1569, 1638, 1569, 2097, 1569, 1569, 1469, 1976, 1469, 1569, 1469, 1976, 1469, 2097, 1976, 2621, 1976, 2097, 1976, 2621, 1976, 1569, 1469, 1976, 1469, 1569, 1469, 1976, 1469, 
  1725, 1613, 2185, 1613, 1725, 1613, 2185, 1613, 1613, 1512, 2064, 1512, 1613, 1512, 2064, 1512, 2185, 2064, 2750, 2064, 2185, 2064, 2750, 2064, 1613, 1512, 2064, 1512, 1613, 1512, 2064, 1512, 1725, 1613, 2185, 1613, 1725, 1613, 2185, 1613, 1613, 1512, 2064, 1512, 1613, 1512, 2064, 1512, 2185, 2064, 2750, 2064, 2185, 2064, 2750, 2064, 1613, 1512, 2064, 1512, 1613, 1512, 2064, 1512, 
  1820, 1707, 2280, 1707, 1820, 1707, 2280, 1707, 1707, 1607, 2160, 1607, 1707, 1607, 2160, 1607, 2280, 2160, 2893, 2160, 2280, 2160, 2893, 2160, 1707, 1607, 2160, 1607, 1707, 1607, 2160, 1607, 1820, 1707, 2280, 1707, 1820, 1707, 2280, 1707, 1707, 1607, 2160, 1607, 1707, 1607, 2160, 1607, 2280, 2160, 2893, 2160, 2280, 2160, 2893, 2160, 1707, 1607, 2160, 1607, 1707, 1607, 2160, 1607, 
  1872, 1759, 2383, 1759, 1872, 1759, 2383, 1759, 1759, 1659, 2212, 1659, 1759, 1659, 2212, 1659, 2383, 2212, 2996, 2212, 2383, 2212, 2996, 2212, 1759, 1659, 2212, 1659, 1759, 1659, 2212, 1659, 1872, 1759, 2383, 1759, 1872, 1759, 2383, 1759, 1759, 1659, 2212, 1659, 1759, 1659, 2212, 1659, 2383, 2212, 2996, 2212, 2383, 2212, 2996, 2212, 1759, 1659, 2212, 1659, 1759, 1659, 2212, 1659, 
  1986, 1873, 2497, 1873, 1986, 1873, 2497, 1873, 1873, 1714, 2322, 1714, 1873, 1714, 2322, 1714, 2497, 2322, 3166, 2322, 2497, 2322, 3166, 2322, 1873, 1714, 2322, 1714, 1873, 1714, 2322, 1714, 1986, 1873, 2497, 1873, 1986, 1873, 2497, 1873, 1873, 1714, 2322, 1714, 1873, 1714, 2322, 1714, 2497, 2322, 3166, 2322, 2497, 2322, 3166, 2322, 1873, 1714, 2322, 1714, 1873, 1714, 2322, 1714, 
};
